(*
Begin anomalistic
*)
Clear["Months`anomalistic`"];
BeginPackage["Months`anomalistic`", "Months`Common`MonthsCommon`"]
Begin["`Private`"];
(*
data
*)
(*
see Months.notes.nb  anomalistic , synodic and lunisolar.  new year is \
peri-apsis on orbit (on the long axis of symmetry of the ellipse, closer side \
of)
*)
DayStart[anomalistic] = 12;
Epoch[anomalistic, anomalistic, text] = "anomalistic in J2000.0";
Epoch[anomalistic, anomalistic, type] = solar;
Epoch[anomalistic, anomalistic, daystart] = 1/2;
Epoch[anomalistic, anomalistic, JDN] = 2451547;
Epoch[anomalistic, anomalistic, CDN] = 0;
Epoch[anomalistic, anomalistic, date] = {0, 1, 1, 12, 0, 0};
Epoch[anomalistic, julian, date] = {1999, 12, 21, 12, 0, 0};
Epoch[anomalistic, gregorian, date] = {2000, 1, 3, 12, 0, 0};
MonthsInYear[anomalistic] = 1;
MonthsInYear[year_, anomalistic] = 1;
leapammount[anomalistic] = 0;
DayNames[anomalistic] = {};
DayNamesStrings[anomalistic] = {};
MonthNames[anomalistic] = {};
MonthNamesStrings[anomalistic] = {};
GreatestDay[anomalistic] = MeanAnomalisticYear;
LesserYear[anomalistic] = MeanAnomalisticYear; 
GreaterYear[anomalistic] = MeanAnomalisticYear;
(*
util
*)
fixdate[dtp_, anomalistic] := Module[{dt, l},
      dt = fixdatebegin[dtp];
      If[dt == $Failed, Return[$Failed]];
      l = Length@dt;
      While[Length@dt < 6, AppendTo[dt, 0]];
      If[dt[[2]] === 0 && l <= 1, dt[[2]] = 1];
      If[dt[[3]] === 0 && l <= 2, dt[[3]] = 1];
      If[dt[[2]] != 1, Message[Months::"unformatted", dt[[2]]]; 
        Return[$Failed]];
      If[dt[[3]] < 1, Message[Months::"unformatted", dt[[3]]]; 
        Return[$Failed]];
      dt
      ] /; ListQ@dtp || dtp \[Element] Integers
ToSeconds2[dtp_, anomalistic] := 
  DayNumberFrom2[dtp, anomalistic, anomalistic] 24 60^2
FromSeconds2[secs_?NumericQ, anomalistic] := 
  DayNumberTo2[secs/(24 60^2), anomalistic, anomalistic]
leapdays[yp_?NumericQ, anomalistic] := 0
leapdays[{y_, ___}, anomalistic] := leapdays[y, anomalistic]
IsLeapYear[year_?NumericQ, anomalistic] := False
IsLeapYear[{year_, ___}, anomalistic] := IsLeapYear[year, anomalistic]
YearFromDays[days_?NumericQ, anomalistic] := Module[{y, ave},
    ave = MeanAnomalisticYear;
    If[days >= 0,
      Quotient[days, ave],
      y = Quotient[Abs@days, ave];
      y = -y; If[y === 0, y = -1];
      y
      ]]
YearFromDays[{days_, ___}, anomalistic] := YearFromDays[days, anomalistic]
DaysInMonth[year_Integer, month_Integer, anomalistic] := MeanAnomalisticYear
DaysInMonth[{year_, month_, ___}, anomalistic] := 
  DaysInMonth[year, month, anomalistic]
MonthDays[year_Integer, month_Integer, anomalistic] := 0
MonthDays[{year_, month_, ___}, anomalistic] := 
  MonthDays[year, month, anomalistic]
DaysInYear[year_?NumericQ, anomalistic] := MeanAnomalisticYear
DaysInYear[{year_, ___}, anomalistic] := DaysInYear[year, anomalistic]
YearDay[year_Integer, month_Integer, day_?NumericQ, anomalistic] := day
YearDay[{year_, month_, day_, ___}, anomalistic] := 
  YearDay[year, month, day, anomalistic]
MonthOfYearDay[year_Integer, yearday_?NumericQ, anomalistic] := 1
MonthOfYearDay[{year_, yearday_, ___}, anomalistic] := 
  MonthOfYearDay[year, yearday, anomalistic]
dayofweek[dt_, anomalistic] := 1
dayofweekName[year_Integer, month_Integer, day_?NumericQ, anomalistic] := ""
dayofweekName[{year_, month_, day_, ___}, anomalistic] := 
  dayofweekName[year, month, day, anomalistic]
(*
End  anomalistic
*)
End[]
EndPackage[]
