(*
Begin  squared
*)
Clear["Months`squared`"];
BeginPackage["Months`squared`", "Months`Common`MonthsCommon`"]
(*
data
*)
(*
HOWTO use any numeric function that can use day number as if a calendar with \
Months`
*)
(*
see Months.notes.nb  squared / calTransform From To
*)
Epoch[squared, squared, text] = "squared";
Epoch[squared, squared, type] = lunar;
Epoch[squared, squared, daystart] = 0;
Epoch[squared, squared, CDN] = 0;
Epoch[squared, squared, JDN] = 2451545;
Epoch[squared, squared, date] = {0, 0, 0, 0, 0, 0};
Epoch[squared, gregorian, date] = {2000, 1, 1, 12, 0, 0};
Epoch[squared, julian, date] = {1999, 12, 19, 12, 0, 0};
(*
utils
*)
Begin["`Private`"];
fixdate[dtp_, squared] := Module[{dt, l},
      (*dt = fixdatebegin[dtp];*)
      dt = dtp;
      If[dt == $Failed, Return[$Failed]];
      l = Length@dt;
      While[Length@dt < 6, AppendTo[dt, 0]];
      dt
      ] /; ListQ@dtp || dtp \[Element] Integers
(*
squared calendar  funs
*)
\!\(calTransformTo[np_?NumericQ, squared] := 
    Module[{n}, 
      n = np - 1; \((Print@np; {0, 0, 
          3.7601335599440503`*^9\ \((29.530588861\[InvisibleSpace] - 
                0.000023062870593228412\ \@\(1.6395229113969543`*^12 - \
\((n)\)\))\), 0, 0, 0})\)]\)
calTransformFrom[mp_?NumericQ, squared] :=
  
  Module[{m}, 
    m = mp + 1; (Print@m; 
      5.597661 + 29.5305888610 m + (102.026 10^-12)m^2 - 
        0.000739 - (235 10^-12)m^2)]
ToSeconds2[dtp_, squared] := DayNumberFrom2[dtp, squared, squared] 24 60^2
FromSeconds2[secs_?NumericQ, squared] := 
  DayNumberTo2[secs/(24 60^2), squared, squared]
(*
calTransformFrom[days_?NumericQ,squared]:=days^2-1
calTransformTo[days_?NumericQ,squared]:={0,0,(days)^(1/2)+1,0,0,0}
*)
(*
End squared
*)
End[]
EndPackage[]
