(*
Begin  synodic
*)
Clear["Months`synodic`"];
BeginPackage["Months`synodic`", "Months`Common`MonthsCommon`"]
(*
data
*)
(*
synodic is NOT accurate to moon, uses average
see Months.notes.nb  nocalendar , synodic and lunisolar
*)
MonthsInYear[synodic] = 1;
leapammount[synodic] = 1;
DayNames[synodic] = {Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, 
      Saturday};
DayNamesStrings[synodic] = Map[SymbolName, DayNames[]];
DayTab[synodic] = {{29}, {30}(*for leap year*)};
MonthDayTab[synodic] = Module[{Private`d, Private`m},
    {Flatten@
        Table[Table[
            Private`m, {Private`d, 
              DayTab[synodic][[1, Private`m]]}], {Private`m, 1, 
            MonthsInYear[synodic]}],
      Flatten@
        Table[Table[
            Private`m, {Private`d, 
              DayTab[synodic][[2, Private`m]]}], {Private`m, 1, 
            MonthsInYear[synodic]}]
      }]
GreatestDay[synodic] = 30; LesserYear[synodic] = 29; 
GreaterYear[synodic] = 30;
(*
MonthNames[synodic]={WaxingCrecent,WaxingGibbius,WaningGibbius,WaningCrecent};\

*)
Epoch[synodic, synodic, text] = "synodic";
Epoch[synodic, synodic, type] = lunar;
Epoch[synodic, synodic, daystart] = 0;
Epoch[synodic, synodic, CDN] = 0;
Epoch[synodic, synodic, JDN] = 2451549 + 1/2;
Epoch[synodic, synodic, date] = {0, 1, 1, 0, 0, 0};
Epoch[synodic, gregorian, date] = {2000, 1, 6, 0, 0, 0};
Epoch[synodic, julian, date] = {1999, 12, 24, 0, 0, 0};
MonthNamesStrings[synodic] = {""};
(*
utils
*)
Begin["`Private`"];
fixdate[dtp_, synodic] := 
  Module[{y, M, d, h, m, s, x, dt, S, calgreg, caljul},
      dt = fixdatebegin[dtp];
      If[dt == $Failed, Return[$Failed]];
      calgreg = Epoch[synodic, synodic, date];
      While[Length@dt < 6, AppendTo[dt, calgreg[[Length@dt + 1]]]];
      {y, M, d, h, m, s} = dt;
      x = MonthsInYear[y, synodic];
      If[M < 1 || M > x, Message[Months::"unformatted", M]; Return[$Failed]];
      x = DaysInMonth[{y, M}, synodic];
      If[d < 1 || d > x, Message[Months::"unformatted", d]; Return[$Failed]];
      If[Quotient[h, 24] != 0, Message[Months::"unformatted", h]; 
        Return[$Failed]];
      If[Quotient[m, 60] != 0, Message[Months::"unformatted", m]; 
        Return[$Failed]];
      If[Quotient[s, 60] != 0, Message[Months::"unformatted", s]; 
        Return[$Failed]];
      dt
      ] /; ListQ@dtp || dtp \[Element] Integers
(*
synodic calendar  funs
*)
(*
ie. 29+1/2+3/100+1/2000+(4/45045)+(1/16453260)//N
*)
MonthsInYear[year_, synodic] := 1
leapdays[yp_?NumericQ, synodic] := Module[{y}, y = Floor[Abs@yp];
    If[Sign[yp] === 0, 1, 
        Sign[yp]]((Plus @@ 
              Map[(Quotient[y, #^-1]) &, {1/2, 3/100, 
                  1/2000, (4/45045), (1/16453260)}]) + If[yp < 0, 0, 1])]
leapdays[{y_, ___}, synodic] := leapdays[y, synodic]
(*
given fraction would need to all be 0 on leap ... \
Mod[y,2]==0&&Mod[y,100/3]==0&&... so
*)
IsLeapYear[year_?NumericQ, synodic] := 
  leapdays[year - 1, synodic] != leapdays[year, synodic]
IsLeapYear[{year_, ___}, synodic] := IsLeapYear[year, synodic]
YearFromDays[days_?NumericQ, synodic] := Module[{y, ave},
    ave = (LesserYear[synodic] + 1/2 + 3/100 + 
          1/2000 + (4/45045) + (1/16453260));
    If[days >= 0,
      Quotient[Floor@days - 1, ave],
      y = Quotient[Floor@Abs@days + LesserYear[synodic] - 1, ave];
      y = -y; If[y === 0, y = -1];
      y
      ]]
YearFromDays[{days_, ___}, synodic] := YearFromDays[days, synodic]
DaysInMonth[year_Integer, month_Integer, synodic] := 
  DayTab[synodic][[If[IsLeapYear[year, synodic], 2, 1], Floor@month]] /; 
    1 <= month <= MonthsInYear[year, synodic]
DaysInMonth[{year_, month_, ___}, synodic] := 
  DaysInMonth[year, month, synodic]
MonthTab[year_?NumericQ, synodic] := 
  DayTab[synodic][[If[IsLeapYear[Floor@year, synodic], 2, 1]]]
MonthTab[{year_, ___}, synodic] := MonthTab[year, synodic]
MonthDays[year_Integer, month_Integer, synodic] := 
  Plus[Sequence @@ Take[MonthTab[Floor@year, synodic], Floor@month]] /; 
    0 <= month <= MonthsInYear[year, synodic]
MonthDays[{year_, month_, ___}, synodic] := MonthDays[year, month, synodic]
DaysInYear[year_?NumericQ, synodic] := 
  If[IsLeapYear[year, synodic], GreaterYear[synodic], LesserYear[synodic]]
DaysInYear[{year_, ___}, synodic] := DaysInYear[year, synodic]
YearDay[year_Integer, month_Integer, day_?NumericQ, synodic] :=
  
  MonthDays[year, month - 1, synodic] + day /; 
    1 <= month <= MonthsInYear[year, synodic] && 
      1 <= day <= DaysInMonth[year, month, synodic]
YearDay[{year_, month_, day_, ___}, synodic] := 
  YearDay[year, month, day, synodic]
(*
MonthOfYearDay[year_Integer, yearday_?NumericQ, synodic] := 
  Module[{month, x, i},
      month = Floor[yearday/GreatestDay[synodic]];
      If[month == 0, Return[1]];
      Do[If[MonthDays[year, month, synodic] >= yearday, Break[]]; ++month, {i,
           1, MonthsInYear[year, synodic]}];
      month
      ] /; 1 <= Floor@yearday <= DaysInYear[year, synodic]
*)
MonthOfYearDay[year_Integer, yearday_?NumericQ, synodic] := 
  MonthDayTab[synodic][[If[IsLeapYear[Floor@year, synodic], 2, 1], yearday]] /;
     1 <= Floor@yearday <= DaysInYear[year, synodic]
MonthOfYearDay[{year_, yearday_, ___}, synodic] := 
  MonthOfYearDay[year, yearday, synodic]
(*
dayofweek[dtp_,synodic]:=Module[{dt},
    dt=fixdate[dtp,synodic];If[dt==$Failed,Return[$Failed]];
    Mod[Floor@DayNumberDifference2[Epoch[SundayYear,synodic,date],dt,synodic],\
7]+1]
*)
dayofweek[dtp_, synodic] := MoonPhase[dtp, synodic, True]
dayofweekName[dtp_, synodic] := MoonPhase[dtp, synodic]
ToSeconds[dtp_, synodic] := DayNumberFrom[dtp, synodic, synodic] 24 60^2
FromSeconds[secs_?NumericQ, synodic] := 
  DayNumberTo[secs/(24 60^2), synodic, synodic]
ToSeconds2[dtp_, synodic] := DayNumberFrom2[dtp, synodic, synodic] 24 60^2
FromSeconds2[secs_?NumericQ, synodic] := 
  DayNumberTo2[secs/(24 60^2), synodic, synodic]
(*
End synodic
*)
End[]
EndPackage[]
