(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     69329,       2471]*)
(*NotebookOutlinePosition[     69998,       2495]*)
(*  CellTagsIndexPosition[     69954,       2491]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["todo", "Subsubsection"],

Cell["\<\
list of functions help.  for sake of brevity, open Months.nb and \
see ::usage at top.  the few symbols not having ::usage are self \
descriptively named just use ??  tests below show some more common tasks.  \
section Day Number 2 begins with common conversion exmaple.\
\>", "Text"],

Cell["?Months`Common`MonthsCommon`*", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["discussion ,  few tests  ,  scraps", "Section"],

Cell["\<\
calendars are \"wall hangars\", never quite right to day (to stars \
they drift: they are perfect to their own rule). but if \"corrected\" then \
all stored / historic dates become wrong

solar calendars show hour. ie, gregorian calendar reads 12 at noon even if it \
does read the wrong day!  the time lost as to 24hr SI days is in leap years \
and that fomula drifts from the stars, and that difference is simply known as \
current drift.

note TAI or GPS are clocks not a calendars, not formulas, but people adjust \
the readout so they appear to match solar events\
\>", "Text"],

Cell[TextData[{
  "in light of astronomy ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " v. 9 does or astronomy on the internet in general,  \nMonths is a \
lightweight converter to and from calendar and JDN which may come in handy at \
times, ie, when finding a point and click web deal won't suffice (or \
exploring effect of epochs is needed). it isn't intended to be a converter \
that will / can do line of sight calculations, no, it's mostly linear but \
convenient when needed"
}], "Text"],

Cell["\<\
it's a good question if there is any existing small celestial sims \
that do cals, epochs, jdn, and conversions of in a way a mm user can make use \
of\
\>", "Text"],

Cell[CellGroupData[{

Cell["warnings , any calendar programs and these", "Subsection"],

Cell[TextData[{
  "auto cal switch\n\tMM v. 4 `Calendar` package assumes that before {1752, \
9, 2} the\n\t\tjulian calander will be used (can be selected though)\n\t? \
historicly 1582 ? is important for the same.\n\t\tMonths stays on calendar \
you choose.\nhistoric dates\n\tNeither of map to historic calendars (diff is \
historically small).\n0 AD\n\t",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ", Julian Day number and (new) Gregorian day number\n\tall think year 0 \
A.D. exists (convenient since for day number and\n\tseconds thinks so)\n\t\t\
some sources say {-1,1,1,0,0,0} {1,1,1,0,0,0} there was no 0.\n\t\tplease \
take -1 off dates in Range[-\[Infinity],0] if you think so.\n\t\t(yes, yr 0 \
was a year before the gregorian calendar started\n\t\t and no that doesn't \
mean this year is one off\n\talso DN counts julian from -4712 which crosses \
and counts 0 as a year\n\tand with that epochs published indicate 0 is \
counted as a year\n\t\tSO be careful if taking advice on whether to count it\n\
\tas for astronomic uses i believe 0 is counted as a rule"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberDifference[{2014, 5, 29, 21, 24, 50}, {1900, 1, 1, 0, 0, 0}, 
        gregorian]\ 24\ 60^2\)], "Input"],

Cell[BoxData[
    \(\(-3610387490\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(FromDate[{2014, 5, 29, 21, 24, 50}]\)], "Input"],

Cell[BoxData[
    \(3610387490\)], "Output"]
}, Open  ]],

Cell["\<\
this shows mm v4 does not respect calendar, be careful with it the \
result it chooses for bad input is not predictable all said and done\
\>", \
"Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FromDate[{0, 0, 1, 0, 0, 20}]\)], "Input"],

Cell[BoxData[
    \(\(-59960908780\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToDate[%]\)], "Input"],

Cell[BoxData[
    \({\(-1\), 12, 1, 0, 0, 20}\)], "Output"]
}, Open  ]],

Cell["this shows mm counts 0 as a year", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FromDate[{0, 1, 1, 0, 0, 20}]\)], "Input"],

Cell[BoxData[
    \(\(-59958230380\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToDate[% + 20]\)], "Input"],

Cell[BoxData[
    \({0, 1, 1, 0, 0, 40}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "input error\n\t",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " v. 4 allows wrong calendar dates as input\n\tand can give wrong dates as \
output (as a result?)\n\t(wrong \"answer\" and impossible date).\n\n\tMonths \
quits if input is wrong and is thought NOT to give\n\t\"fake\" dates for the \
few cal it does support.  note\n\tepochs are by day number unless they have \
calendar\n\tMonths knows.  HOWEVER.  anomalistic, squared \"demo\"\n\t\
calendars are do no input checking."
}], "Text"],

Cell["\<\
A final warning: one cannot convert to julian, add days time, and \
expect gregorian days were the same
\tjulian    ruler: 365 + 1/4 (every 4)
\tgregorian ruler: 365 + 1/4 - 1/100 + 1/400 (every ...)
One steps on ruler by 365.  If an extra whole marking (day) is left, it's a \
leap year a day is added.  BUT time does not flow evenly along either, today \
diff. is 13 days.  Result: if time is added in one time scale conversion back \
is needed, use the conversion function whenever time was changed between \
conversions.\
\>", "Text"],

Cell["\<\
say you hear julain date is 13 days behind gregorian.  \
PrettyDate[Date[],julian] shows 3 days.  no!  \
PrettyDate[gregorianTojulian@Date[],julian]  is what you meant.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["an important note about any calendar conversion", "Subsection"],

Cell["\<\
there is something obvious yet subtle to realize about conversion

time doesn't flow evenly between calendar years HOWEVER the hour must always \
flow the same

what that means is between julian and gregorian some date may differ by days \
but not in hour.  that means year and month are converted time isn't going \
both ways in conversions.

daystart can be different and that's continually something to be aware of \
that may need attention.  going between epochs.  say {0,1,3,0} is first \
julian cal day on gregorian day 0.  the difference is two days clean.  \
however if use it against julian day 0 {0,1,1,12,0} it's 1.5 days which is \
incorrect to compare with for for the case mentioned.

daystart has another oddity.  Scaliger jdn, and dn2 as well, do this
\t{0,1,1,12,0,0} jdn 0 starts, day 1 of calendar
\t{0,1,2,0,0,0}  jdn .5 , still day 1
\t{0,1,2,12,0,0} jdn 1 starts
\tAHA ! we should count [12,36] hr
\tor [12:00am-11:59am,12:00pm-11:59pm]
\twe have to read 2,0 as 2nd half of day 1 !

365.24 or 365.25 cannot be applied as multiples to seconds because the hour \
would change which is never the purpose of calendars (to keep days whole and \
counted)

that said some calendars count whole solar body appearance counting and leave \
day lenght uncounted: this requires observation or simulation which may not \
be easy to comput, and to provide an inverse may be implausible \
\>", "Text"],

Cell["\<\
julian is now 13 days off from seasonal year (gregorian, though is \
also off) (solar, see below)

julian is always 365.25 solar days/year, 24/60/60 and IS UN-adjusted, as if a \
ruler (why used in astro. eq. if one used floating formula then adjustements \
would be impossible to state!)

if correction to gregorian is made for season it'd no long be usable for past \
or future dates anyone has recorded: it'd be a new calendar system.  rather \
the tradition so far is to publish dates with corrections rather than to \
create another differing new calendar.\
\>", "Text"],

Cell["\<\
if you didn't know gregorian is a seasonal calendar (by equinox, \
not by solar passes), there are lunar and solar, and TAI is a clock.  \
tropical solar v. anomalistic seasonal are off by a day every 180 ? years so \
should have their own calendar.  seasonal is the standard but as said above a \
calendar is \"rigid\" and reflects day only for a period from the time it \
from which it's epoch began.  there is no TAI in the (ancient) past no one \
knows for sure what time it was \"excactly\" for observations.\
\>", "Text"],

Cell["\<\
Wikipedia: \"In astronomy the julian calendar is rarely used , it \
moves unevenly.  Instead, ie J2000.0 is used with respect to some epoch (usu. \
JDN 0) , as above time is assumed to flow evenly , and which calendar day \
anything falls on.is DISREGUARDED.\"

\tWait!  this does not answer a question if JDN is not the formula advertised
\t365+1/4 equinoctal (mean tropical) solar days
\t\t(which on calendar are calendarized to make days whole)
\t\t
\timportant: according to current publishings the above statement is UNTRUE
\tor confusing.  why ?  TAI uses 12pm to align with julian 12pm and they do
\tmean solar meridian (shows the above is wrong).  if julian was construed
\tto be 365+1/4 SI seconds then any statement of JDN 12pm would never
\treflect solar position.
\t
365+1/4 solar days means n days +- one day (every 4 years).  days are 24hhr \
during year and back to back YES.  BUT SI seconds are absobed annualy at \
observation of sun being on azimuth on the 366 day \"the new year\" begins \
(julian cal), and hr runs from 0!  how could that be?  absorbed is how.  as \
to the 1/4 that is held in calendar and every for years 367 days is used.  \
this method DOES fail to follow the seasons over many years and that effect \
is left uncorrected

\ttoday TAI is in use so they know how many seconds julian/gregorian
\tabsorbed each year, and typical solar calculations can predict
\tfar into the future with a small polynomial but the time lost
\tis not calendarized.

so how does TAI get to be noon on julian noon ?  it doesn't.  an epoch is \
chosen when the two happen to align ! mixed epochs are breifly discussed in \
section below.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["an important note about astronomy", "Subsection"],

Cell[TextData[{
  "new ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " has a nice \"solar system emulator\" however i'm unsure as a package how \
many astronomical features are offered externally (in .m form you can see). \
surely there are proffesional mm packages to buy"
}], "Text"],

Cell["\<\
free constants, equations, and other ephemerides can be found for \
free at http://asa.usno.navy.mil/SecK/Constants.html and many other online \
sources.  there are free many simulators (ie, stellarium is a small one) and \
methods (for satellite work, much more complicated equations).  there are \
also free softwares for nautical maps which also simulate and use similar \
data, also using (GMT or gps/TAI in gmt format) Ra, Dec, h\
\>", "Text"],

Cell["\<\
a note of caution is that JPL or ground/space observatories use \
JDN, Ra, Dec, h, ellipse and other datum in a standard way.  Deviating from \
that would limit one's ability to use such (free) and valued published \
data.\
\>", "Text"],

Cell["\<\
(one should realize there may be corrections to be applied, such as \
atmospheric effect of size of object, and be wary about what is or isn't yet \
\"corrected\" in data and whether data has flight value or even distant \
future value)\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["test after load package", "Subsection"],

Cell[BoxData[
    \(<< Months`Months`\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(MonthNames[julian]\)], "Input"],

Cell[BoxData[
    \({Ianuarius, Februarius, Martius, Aprilis, Maius, Iunius, Quintilis, 
      Sextilis, September, October, November, December}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?Months`*\)\)], "Input"],

Cell[BoxData[
    \(Information::"nomatch" \(\(:\)\(\ \)\) 
      "No symbol matching \!\(\"Months`*\"\) found."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?Months`gregorian`*\)\)], "Input"],

Cell[BoxData[
    \("Months`gregorian`zzz"\)], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?Months`julian`*\)\)], "Input"],

Cell["\<\
Aprilis    giovedi    lunedi     Martius    Quintilis  Sextilis   \
venerdi
domenica   Ianuarius  Maius      mercoledi  sabato     syndodic   zzz
Februarius Iunius     martedi\
\>", "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? Miscellaneous`Calendar`*\)], "Input"],

Cell[BoxData[
    \(Information::"nomatch" \(\(:\)\(\ \)\) 
      "No symbol matching \!\(\"Miscellaneous`Calendar`*\"\) found."\)], \
"Message"]
}, Open  ]],

Cell["\twill show nothing of it's own", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?Months`anomalistic`*\)\)], "Input"],

Cell[BoxData[
    \("Months`anomalistic`zzz"\)], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? MonthNames\)], "Input"],

Cell[BoxData[
    \("Months`Common`MonthsCommon`MonthNames"\)], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(MonthNames[] := 
                    MonthNames[
                      calendar /. \[InvisibleSpace]Options[Months]]\)},
                {" "},
                {\(MonthNames[gregorian] = {January, February, March, April, 
                      May, June, July, August, September, October, November, 
                      December}\)},
                {" "},
                {\(MonthNames[julian] = {Ianuarius, Februarius, Martius, 
                      Aprilis, Maius, Iunius, Quintilis, Sextilis, September, 
                      October, November, December}\)},
                {" "},
                {\(MonthNames[nocalendar] = {}\)},
                {" "},
                {\(MonthNames[synodic] = {January, February, March, April, 
                      May, June, July, August, September, October, November, 
                      December}\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ MonthNames],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrettyDate[Date[], gregorian]\)], "Input"],

Cell[BoxData[
    \("Thursday, June 5 2014.  10:24:58 p.m. -4\[ThinSpace]GMT"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?gregorian\)\)], "Input"],

Cell[BoxData[
    \("is package in Months`gregorian adding that feature set"\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["lack of tests  gregorian", "Subsection"],

Cell["uci[\"cal -y\"]", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? Months\)], "Input"],

Cell[BoxData[
    \("gregorian and julian Months , a few Astronomical conversions.  if you \
load calendar` after a few help items will change in default context search \
path."\)], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(Options[Months] = {calendar \[Rule] gregorian, 
                      DayNumberBy \[Rule] julian}\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ Months],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(MonthNames[julian]\)], "Input"],

Cell[BoxData[
    \({Ianuarius, Februarius, Martius, Aprilis, Maius, Iunius, Quintilis, 
      Sextilis, September, October, November, December}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(MonthNames[gregorian]\)], "Input"],

Cell[BoxData[
    \({January, February, March, April, May, June, July, August, September, 
      October, November, December}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? MonthNames\)], "Input"],

Cell[BoxData[
    \("Months`Common`MonthsCommon`MonthNames"\)], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(MonthNames[] := 
                    MonthNames[
                      calendar /. \[InvisibleSpace]Options[Months]]\)},
                {" "},
                {\(MonthNames[gregorian] = {January, February, March, April, 
                      May, June, July, August, September, October, November, 
                      December}\)},
                {" "},
                {\(MonthNames[julian] = {Ianuarius, Februarius, Martius, 
                      Aprilis, Maius, Iunius, Quintilis, Sextilis, September, 
                      October, November, December}\)},
                {" "},
                {\(MonthNames[nocalendar] = {}\)},
                {" "},
                {\(MonthNames[synodic] = {January, February, March, April, 
                      May, June, July, August, September, October, November, 
                      December}\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ MonthNames],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dayofweekName[Date[]]\)], "Input"],

Cell[BoxData[
    \("Sunday"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dayofweek[Take[Date[], 3], gregorian]\)], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberDifference[{2011, 12, 30}, {2012, 1, 2}, julian]\)], "Input"],

Cell[BoxData[
    \(3\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dtsdaysbetween[{2011, 12, 30}, {2012, 1, 2}, gregorian]\)], "Input"],

Cell[BoxData[
    \(3\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(daystoSunday[Date[], gregorian]\)], "Input"],

Cell[BoxData[
    \(903\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(daystoSunday[{2012, 1, 2}, gregorian]\)], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(daystoSunday[{2011, 12, 31}, gregorian]\)], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dtsdayofweek[{2012, 1, 1}, gregorian]\)], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dtsdayofweek[{2012, 1, 2}, gregorian]\)], "Input"],

Cell[BoxData[
    \(2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dtsdayofweek[{2011, 12, 31}, gregorian]\)], "Input"],

Cell[BoxData[
    \(7\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dtsdayofweek[{2011, 12, 30}, gregorian]\)], "Input"],

Cell[BoxData[
    \(6\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dtsdayofweek[{2012, 1, 8}, gregorian]\)], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? DayNamesStrings\)], "Input"],

Cell[BoxData[
    \("used in Months`, see Months.m"\)], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(DayNamesStrings[] := 
                    DayNamesStrings[
                      calendar /. \[InvisibleSpace]Options[Months]]\)},
                {" "},
                {\(DayNamesStrings[gregorian] = {"Sunday", "Monday", 
                      "Tuesday", "Wednesday", "Thursday", "Friday", 
                      "Saturday"}\)},
                {" "},
                {\(DayNamesStrings[julian] = {"Sunday", "Monday", "Tuesday", 
                      "Wednesday", "Thursday", "Friday", "Saturday"}\)},
                {" "},
                {\(DayNamesStrings[nocalendar] = {}\)},
                {" "},
                {\(DayNamesStrings[synodic] = {"Sunday", "Monday", "Tuesday", 
                      "Wednesday", "Thursday", "Friday", "Saturday"}\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ DayNamesStrings],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNamesStrings[]\)], "Input"],

Cell[BoxData[
    \({"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", 
      "Saturday"}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(MonthNamesStrings[]\)], "Input"],

Cell[BoxData[
    \({"January", "February", "March", "April", "May", "June", "July", 
      "August", "September", "October", "November", "December"}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dtsdayofweekName[{2012, 1, 3}, gregorian]\)], "Input"],

Cell[BoxData[
    \("Tuesday"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dtsdaysbetween[{2011, 12, 30}, {2012, 1, 2}, gregorian]\)], "Input"],

Cell[BoxData[
    \(3\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrettyDate[julian]\)], "Input"],

Cell[BoxData[
    \("Monday, June 9 2014.  11:11:17 p.m. -4\[ThinSpace]GMT"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrettyDate[gregorian]\)], "Input"],

Cell[BoxData[
    \("Sunday, June 22 2014.  11:11:20 p.m. -4\[ThinSpace]GMT"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrettyDate[]\)], "Input"],

Cell[BoxData[
    \("Sunday, June 22 2014.  11:14:37 p.m. -4\[ThinSpace]GMT"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrettyDate[Date[], gregorian]\)], "Input"],

Cell[BoxData[
    \("Sunday, June 22 2014.  11:14:38 p.m. -4\[ThinSpace]GMT"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dayofweekName[gregorianTojulian@Date[], julian]\)], "Input"],

Cell[BoxData[
    \("Saturday"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PrettyDate[julian]\)], "Input"],

Cell[BoxData[
    \("Saturday, Iunius 9 2014.  11:14:39 p.m. -4\[ThinSpace]GMT"\)], "Output"]
}, Open  ]],

Cell["this found gave in DayNumber for gregorian", "Text"],

Cell["Solve[y 365 + y/4 - y/100 + y/400 == days, y]", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberDifference[gregorianTojulian@{2012, 1, 1, 0, 0, 0}, 
        gregorianTojulian@{6, 1, 1, 0, 0, 0}] // N\)], "Input"],

Cell[BoxData[
    \(\(-732676.`\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberDifference[{2012, 1, 1, 0, 0, 0}, \[IndentingNewLine]{6, 1, 1, 
        0, 0, 0}, gregorian]\)], "Input"],

Cell[BoxData[
    \(\(-732676\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberDifference[{2012, 1, 1, 0, 0, 0}, \[IndentingNewLine]{6, 1, 1, 
        0, 0, 0}, gregorian]\)], "Input"],

Cell[BoxData[
    \(\(-732676\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Epoch[SundayYear, gregorian, date]\)], "Input"],

Cell[BoxData[
    \({2012, 1, 1, 0, 0, 0}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(Clear[x];\)\)], "Input"],

Cell[BoxData[
    \(\(x = Epoch[SundayYear, gregorian, date];\)\)], "Input"],

Cell[BoxData[
    \(\(Epoch[SundayYear, gregorian, date] = {6, 1, 1, 0, 0, 0};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Timing@dtsdayofweekName[{2012, 1, 1, 0, 0, 0}, gregorian]\)], "Input"],

Cell[BoxData[
    \({0.12`\ Second, "Sunday"}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(daystoSunday[{2012, 1, 1, 0, 0, 0}, gregorian]\)], "Input"],

Cell[BoxData[
    \(732676\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(Epoch[SundayYear, gregorian, date] = x;\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(daystoSunday[{6, 1, 1, 0, 0, 0}, gregorian]\)], "Input"],

Cell[BoxData[
    \(732676\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dtsdayofweekName[{6, 1, 1, 0, 0, 0}, gregorian]\)], "Input"],

Cell[BoxData[
    \("Sunday"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Mod[Floor@DayNumberFrom[Date[], gregorian, julian], 7] + 1\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(7\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom[{\(-4712\), 1, 1, 13, 0, 0}, julian] // N\)], "Input"],

Cell[BoxData[
    \(0.041666666666666664`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dayofweek[{\(-4712\), 1, 5, 15, 0, 0}, julian]\)], "Input"],

Cell[BoxData[
    \(5\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dayofweek[{\(-4712\), 1, 5, 10, 0, 0}, julian]\)], "Input"],

Cell[BoxData[
    \(4\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Day Number  2", "Subsection"],

Cell["\<\
Date and JDN , a many ways in Months.  remember that a larger day \
count in julian cal will not go forward same days on greg. cal, and remember \
julian has a 12pm daystart.\
\>", "Text"],

Cell[BoxData[
    \(\(x = Date[];\)\)], "Input"],

Cell[BoxData[
    \(\(DayNumberChange2[DayNumberFrom2[x, gregorian, gregorian], gregorian, 
        julianDayNumber];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberTo2[%, julianDayNumber, gregorian]\)], "Input"],

Cell[BoxData[
    \({2014, 6, 22, 23, 16, 3}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(DayNumberFrom[x, gregorian, julian];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberTo2[%, julianDayNumber, gregorian]\)], "Input"],

Cell[BoxData[
    \({2014, 6, 22, 23, 16, 3}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(jdn = julianToJDN@DayNumberFrom2[x, gregorian, julian];\)\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(jdn\)\" is similar to \
existing symbol \"\!\(JDN\)\"."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberTo2[%, julianDayNumber, gregorian]\)], "Input"],

Cell[BoxData[
    \({2014, 6, 22, 23, 16, 3}\)], "Output"]
}, Open  ]],

Cell["\tis 13 days behind in 2014, exactly", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(calendarChange2[Date[], gregorian, julian]\)], "Input"],

Cell[BoxData[
    \({2014, 6, 9, 23, 16, 26}\)], "Output"]
}, Open  ]],

Cell["\<\
note
* counting days on julian cal not same as on gregorian cal due to leaps
* DayNumberFrom only works in julian days (JDN)
  (dates it can convert from to gregorian)
* DayNumberFrom2 works for ANY calendar and epoch, days
  and can go from one to other\
\>", "Text"],

Cell[BoxData[
    \(\(DayNumberFrom[x, gregorian, julian];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberTo[%, gregorian, julian]\)], "Input"],

Cell[BoxData[
    \({2014, 6, 22, 23, 16, 3}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(gdn = DayNumberFrom2[x, gregorian, gregorian];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Take[DayNumberTo2[jdn, \ julianDayNumber, \ gregorian], \ 
        5]\  == \ \n\ \ Take[DayNumberTo2[gdn, \ gregorian, \ gregorian], \ 
        5]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell["\t(Take: there is a note below about accuracy and DayNumber)", "Text"],

Cell[BoxData[
    \(Clear[x, jdn, gdn]\)], "Input"],

Cell["DayNumberFrom2 and DayNumberTo2", "Text"],

Cell["\<\
DayNumber formulas i have yet to see explination of magic numbers \
for.

THEORY: it's easy to know days to Gegorian Epoch because Gregor used simple \
100 and 400 leapdays is one step.  and i'd guess julian would follow with \
minor adjustment.  i'm unsure why JDN eq. with limitations are being used or \
whether they are not somehow the same in hiding.  if they are poorly \
conditioned it should be fixed and this should do it.

(the diff to julian Day Number Epoch is even and constant so that can be used \
if careful)\
\>", "Text"],

Cell["\<\
hacking notes

daystart subtracted off before yielding day number From a date (before month \
calc. if neg.) and added back before calculating a number To a date.

epoch start is used for differencing with like dates NOT in calendar origin.  \
ie, {0,1,2} is epoch and date is {0,1,3}, day number uses 2.  it doesn't \
subtract the two \"automagically\" because some epochs are not meant to be \
day 0 of cal.  add or take from param. if you want that or copy a new .nb and \
make a calendar for such things.  if cal tart is 1977 is 1977 a leap year?  \
too confusing.\
\>", "Text"],

Cell["\<\
question: but isn't mm v. 4 Private`DateToNumber[] a day number ? \
no. it ignores days and hours To but always gives days (no hours) From\
\>", \
"Text"],

Cell["\<\
question: isn't mm v.4 FromDate[] a day number ? it isn't part of \
the Calendar package so i wouldn't trust it except for use with (unix/pc) \
time.\
\>", "Text"],

Cell["\<\
\tworks for Julian or Gregorian calendar (maybe more)
\tquick, epoch per cal, and nothing magic (readable code)

\tonce needle in haystack year is found quickly
\tthe minor details (days given year) is done by the same
\tutil funs for prettydate\
\>", "Text"],

Cell["DayNumberFrom2", "Text"],

Cell["\<\
^ note: d-1 start DN at 0. y-1, don't add this years leap if any \
it's in Feb.

note 2: when y<0 both calendar and hour step backward, and the above does \
that.  leapdays is signed.\
\>", "Text"],

Cell["Now the same in reverse.", "Text"],

Cell["DayNumberTo2", "Text"],

Cell["\<\
^ note: for y, stepping by gave on ruler is by yr but by 365 \
occasionally needs extra whole days to cycle next yr (leaps). if y is known \
leaps follows easily. the -1 in quotient (ie, for year 0, 1 is beginning of \
first day and 366 is beginning of last day)

note 2: if leapyear, day will be added to Feb by M below. (next year the \
extra day needs accounting for)

note 3: either {0,12,23,59,59.99_} OR {1,1,1,0,0} could be 366 days depends \
on equation above. it chose whole number dates for whole number days and gets \
left with a correction to make which is now in turn due to note 1 (could \
subtract an inf. fraction but assume knowing how small is \"right\" for \
platform is to be avoided).  no need to update leaps.  similarly if sign y is \
positive a correction is needed at some years far in the future (difficult to \
detect. one knows it's a divide problem because a day ahead or behind is \
never lost and the correction is always on edge of a ruler mark landing).

note 4: greg synodic use same formula diff ave. but see months.notes.nb there \
are removed points to be aware of (due to frac impossible close: so just \
check d is in year afterward).  also: if year 0 wasn't a leap it'd need a \
little modification for that.

(easy meaning for any given query no complicated equations need be solved and \
no loop more than a few iterations is done, it is for all purposes \"an \
euqation\")

(gave==365.2425 is a close approx. of a solar year ancient scholars used. \
since the real solar year fluctuates and shortens, a better constant would \
not help)\
\>", "Text"],

Cell["\<\
DayNumberChange2

note 1 ex julian->gregorian (daystartFrom-daystartTo) is imbibed in ie. \
Epoch[julian,gregorian] (if not greg date wouldn't read noon at julian noon, \
unusual and wrong here).  we find out when checking Epoch[gregorian] which is \
necessary for variety epoch* but moreso we'd not know gregorian date daystart \
no matter.  anyway don't daystart dsf-dst !

* ie, TAI 1977 epoch does NOT start at 1977:0 it just collects dates at that \
time.  that 0 is daystart.  but if it weren't we wouldn't know unless told.  \
an epoch could have dates at 1,12,0,0,0 but have 0 daystart (and if all epoch \
entries were the same, a computer wouldn't know which).  GPS(TAI)=TAI-19 and \
was 0 in 1980, however \"the convention\" is NOT to use 1980 as 0 (that 0 is \
internal to specific if no one counts from 0 at 1980).  point: they don't use \
a rigid rule you have to know and code daystart if applicable to epoch you \
make.\
\>", "Text"],

Cell[BoxData[
    \(\(Months`gregorian`Private`dbg = False;\)\)], "Input"],

Cell["\<\
Table[Append[DayNumberTo[i,gregorian,gregorian],i],{i,-364-365-365-\
365,-370-365-365-365-365,-.25}]//TableForm\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom2[{10^15, 1, 3, 0, 0, 0}, gregorian, gregorian]\)], "Input"],

Cell[BoxData[
    \(365242500000000002\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberTo2[%, gregorian, gregorian]\)], "Input"],

Cell[BoxData[
    \({1000000000000000, 1, 3, 0, 0, 0}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(Module[{x, y, 
          z}, \[IndentingNewLine]Table[\[IndentingNewLine]z = 
            DayNumberTo2[i, gregorian, gregorian]; \[IndentingNewLine]y = 
            DayNumberFrom2[z, gregorian, 
              gregorian]; \[IndentingNewLine]Flatten@{i, 
              y}, \[IndentingNewLine]{i, \(-10.25\), 
            10,  .25}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(% // ListPlot\)], "Input"],

Cell[BoxData[
    \(\(Module[{x, y, 
          z}, \[IndentingNewLine]Table[\[IndentingNewLine]z = 
            DayNumberTo2[i, gregorian, gregorian]; \[IndentingNewLine]y = 
            DayNumberFrom2[z, gregorian, 
              gregorian]; \[IndentingNewLine]Flatten@{i, 
              y}, \[IndentingNewLine]{i, \(-10.23\)\ 10000, 
            10\ 10000,  .24\ 10000}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(% // ListPlot\)], "Input"],

Cell["\tjul day starts at {0,1,1,12,0,0,0}", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberTo2[\(- .1\), julian, julian]\)], "Input"],

Cell[BoxData[
    \({0, 1, 1, 9, 35, 59.999999999992326`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom2[%, julian, julian]\)], "Input"],

Cell[BoxData[
    \(\(-0.10000000000000009`\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberTo2[%, julian, julian]\)], "Input"],

Cell[BoxData[
    \({0, 1, 1, 9, 35, 59.999999999992326`}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(Module[{x, y, 
          z}, \[IndentingNewLine]Table[\[IndentingNewLine]z = 
            DayNumberTo[i, julian, julian]; \[IndentingNewLine]y = 
            DayNumberFrom[z, julian, julian]; \[IndentingNewLine]Flatten@{i, 
              y}, \[IndentingNewLine]{i, \(-10.25\), 
            10,  .25}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(% // ListPlot\)], "Input"],

Cell[BoxData[
    \(\(Module[{x, y, 
          z}, \[IndentingNewLine]Table[\[IndentingNewLine]z = 
            DayNumberTo2[i, julian, julian]; \[IndentingNewLine]y = 
            DayNumberFrom2[z, julian, julian]; \[IndentingNewLine]Flatten@{i, 
              y}, {i, \(-10.23\)\ 10000, 
            10\ 10000,  .24\ 10000}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(% // ListPlot\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom[{\(-4712\), 1, 1, 12, 0, 0}, julian, julian]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom2[{0, 1, 1, 12, 0, 0}, julian, julian]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom2[{\(-1\), 12, 31, 0, 0, 0}, gregorian, gregorian] // 
      N\)], "Input"],

Cell[BoxData[
    \(\(-1.`\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom2[{\(-1\), 12, 31, 23, 6, 0}, gregorian, gregorian] // 
      N\)], "Input"],

Cell[BoxData[
    \(\(-0.0375`\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom2[{\(-1\), 12, 31, 11, 6, 0}, julian, julian] // 
      N\)], "Input"],

Cell[BoxData[
    \(\(-1.0375`\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberDifference2[Epoch[gregorian, gregorian, date], 
      Epoch[julianDayNumber, gregorian, date], gregorian]\)], "Input"],

Cell[BoxData[
    \(\(-\(3442119\/2\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberChange2[
      DayNumberFrom2[{2014, 5, 30, 11, 2, 25}, gregorian, gregorian], 
      gregorian, julianDayNumber]\)], "Input"],

Cell[BoxData[
    \(42453641549\/17280\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom[{2014, 5, 30, 11, 2, 25}, gregorian, julian]\)], "Input"],

Cell[BoxData[
    \(42453641549\/17280\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(% - %%\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell["\<\
ok problem is +- 1 only on boundry leap years on whatever date
\tdn2je says 4713 to 4712 greg has 365 , which is right ?
\t\twrong.
\t\t\tfrom -4713 to -4712 a year later
\t\t\t-4713 is not a leap year but -4712 is (/4)
\t\t\t\tfeb of -4712 is passed\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberChange2[
      DayNumberFrom2[{\(-4712\), 11, 24, 12, 0, 0}, gregorian, gregorian], 
      gregorian, julianDayNumber]\)], "Input"],

Cell[BoxData[
    \(366\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom[{\(-4712\), 11, 24, 12, 0, 0}, gregorian, 
      julian]\)], "Input"],

Cell[BoxData[
    \(366\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(julianToJDN@
      DayNumberFrom2[{\(-4713\), 1, 1, 12, 0, 0}, julian, julian]\)], "Input"],

Cell[BoxData[
    \(\(-365\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom[{\(-4713\), 1, 1, 12, 0, 0}, julian, julian]\)], "Input"],

Cell[BoxData[
    \(\(-365\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(% - %%\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell["\<\
DayNumber from (source) and Daynumber2 can test equality until \
small fractions of sections begin to vary.  the distance (julian) between is \
(subtract one for neg. years)\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberDifference[Epoch[julianDayNumber, julian, date], 
      Epoch[julian, julian, date], julian]\)], "Input"],

Cell[BoxData[
    \(1721058\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberChange2[0, gregorian, julian]\)], "Input"],

Cell[BoxData[
    \(3\/2\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(Clear[x]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(x = Date[]\)], "Input"],

Cell[BoxData[
    \({2014, 6, 22, 23, 19, 17}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(gregorianTojulian@x\)], "Input"],

Cell[BoxData[
    \({2014, 6, 9, 23, 19, 17}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(calendarChange2[x, gregorian, julian]\)], "Input"],

Cell[BoxData[
    \({2014, 6, 9, 23, 19, 17}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(calendarChange2[%, julian, gregorian]\)], "Input"],

Cell[BoxData[
    \({2014, 6, 22, 23, 19, 17}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(x = {\(-4713\), 11, 24, 12, 0, 0};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(gregorianTojulian@x\)], "Input"],

Cell[BoxData[
    \({\(-4712\), 1, 1, 12, 0, 0}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(calendarChange2[x, gregorian, julian]\)], "Input"],

Cell[BoxData[
    \({\(-4712\), 1, 1, 12, 0, 0}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(calendarChange2[%, julian, gregorian]\)], "Input"],

Cell[BoxData[
    \({\(-4713\), 11, 24, 12, 0, 0}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(Clear[x]\)], "Input"],

Cell["code notes", "Text"],

Cell["\<\
\tthis was made to work backwards a little faster but
\thas a bug of working fine until a few thousand years later
\t\tthe -2 offset breaks
\tthat is why the code is in use is the longer way that is
\tlike the positive direction\
\>", "Text"],

Cell["\<\
(*
  y=Quotient[Floor@days+GreaterYear[calFrom]-2,gave];
  y=-y; If[y===0&&days<LesserYear[calFrom],y=-1];
  leaps=leapdays[y,calFrom];
  If[IsLeapYear[sign y,calFrom],leaps=leaps+1];
  d=LesserYear[calFrom] y-2+days-leaps;
  d=-d;
  (*see note 3*)
  If[d<1,y=y-1; d+=DaysInYear[y,calFrom]]
  *)\
\>", "Text"],

Cell["\<\
\tSpeed isn't great but it fixes dates, works with non-julian and
\tmultiple calendars, and is readable.  there are a few ways to speed it
\tup though i'm not too interested.  ie, rid checking\
\>", "Text"],

Cell["\<\
------------------------------------
discuss conversion

calendar day is the expression of 24 hr days onto a calendar system.  show:

\t\t\tDayNumberTo[greg daynum + jul off, julian]
\t\t==\tjulian calendar day of greg daynum

given\tgreg daynum
\t\tg gregscale-gdaynum\[Equal]0;
find \tj julscale-gdaynum-juloff==0;
\t\tj\[Equal]((gdaynum)+juloff)/julscale;
\t\tj julscale-jdaynum==0;
\t\tjdaynum==((gdaynum)+juloff);

gdaynum is in 24hr days exactly.  does gdaynum on greg cal retain partial \
leaps ? no. it has all past leaps except this year, and this year is in days \
total (DayNumber did this).

let j on it's scale == hrdays (incl initial offset).  j can then be expressed \
on julian calendar.

j and g dissapeared which sugg. jdaynum is always gdaynum+off no matter the \
year.  isn't that wrong?  however by applying DayNumberTo[gdaynum+off,julian] \
the 24 hr days will scale onto julian calendar by application of it's rules\
\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Julian Day Number ,  Julian ,  and epochs", "Subsection"],

Cell[CellGroupData[{

Cell["julian Day Number", "Subsubsection"],

Cell["see:  http://quasar.as.utexas.edu/BillInfo/JulianDatesG.html", "Text"],

Cell["\<\
calendars are seasonal time , not often corrected to fit apparent \
solar time (tropical time) (well actaully current solar place in sky which \
vary quite allot).\
\>", "Text"],

Cell["\<\
julian Day Number is the number of days measured from -J4712 at \
noon (see JDN Epoch)

Note julian day starts at 12 but also at that time the clock is read as 12. \
gregorian starts at 0 and reads as 0.\
\>", "Text"],

Cell["\<\
DayNumberFrom

thus \"2014 CE\" corresponds to \"AD 2014\", and \"399 BCE\" corresponds to \
\"399 BC\"

\"This method will not give dates accurately on the Gregorian Proleptic \
Calendar, i.e., the calendar you get by extending the Gregorian calendar \
backwards to years earlier than 1582. using the Gregorian leap year rules. In \
particular, the method fails if Y<400 CE.\"\
\>", "Text"],

Cell["\<\
IF YOU READ:  \"we are thinking of January and February as being \
the 13th and 14th month of the previous year\".  ah!  but algorithm uses 12 \
month year.  don't get confused: it's not intercalar addition, no.  don't \
fall for that.\
\>", "Text"],

Cell["\<\
DayNumberTo

quotes: \"However, it does not work with negative Julian Day Numbers and does \
not work when going to the Gregorian calendar for years before 400 CE\"

what is the Y<400 thing and \"no -J years\" thing ?  i asked a prof. and he \
told me he thought he remembered it was a warning about calculator \
limitations (plausible).\
\>", "Text"],

Cell[TextData[{
  "on the other hand mean tropical year is short by -1.9s / yr about due to \
precession, so every 121.81 yr (greg?) that's a whole day both calendars are \
incorrect.  despite if the -1.9sec/yr is correct, we suspect that after a \
while both calendars are correct to themselves but not the season.  But that \
may be wrong because \"all astronomers know that, duh\" (maybe they wouldn't \
cite \"julian calendar looses days\" since they used julian specifically \
because it is constant and not yet corrected)\n\nDayNumber From/To 2 are \
corrected for division issues, HOWEVER i didn't correct DayNumber (left \
formula as i found it) i think ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " does a rather good job with division.  and if there was a problem with \
DayNumber (point removal / boundry error) fixdate would eventually tell you \
(year one off, too many days, easy fix).  It'd be be very rare to find in DN. \
 compared to modern software standards: today they wouldn't even consider \
that a problem!\n\nIn short.  Many online sources cite the warnings.  It's \
likely just people doing cut and paste the citation and are unsure why the \
error was first cited."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["other jdn epoch uses", "Subsubsection"],

Cell["\<\
many epochs have a -J4712 equivalent

a lilian date counts greg days  Oct 15, 1582 and (gregorian cal author?)  \
floor (JDepoch - 2299159.5)

(many examples)
Unix Time, count of seconds,  0h Jan 1, 1970  (JD - 2440587.5) 86400\
\>", \
"Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["NewEpoch", "Subsubsection"],

Cell["\<\
auto fill in new epoch having little data from a fuller epoch (by \
correlating)

consider NewEpoch experimental not well tested

example.  one is given a J2000 date or two and wants to know JDN. one has \
another epoch with these. NewEpoch should be able to expose JDN without need \
of the user \"directing a string of conversions\"\
\>", "Text"],

Cell["\<\
Example:  see if From TAI adds new epochs To julian.  it will \
julian,date in both and if there is no TAI in julian, try to make one. it \
sees julian in TAI, and sees epoch is some 4*^6 away. it would also have \
added a JDN entry in julian had it not already been there (if dist is known \
and one has JDN, JDN of the other is revealed).

\tNewEpochFrom[TAI,julian,{julian,date}]
\t<SNIP>
\tEpoch[julian,TAI,CDN]:=4.1642025003725*^6;\
\>", "Text"],

Cell["\<\
possible CDN confuson

julian<-TAI can put Epoch[julian,TAI,CDN] in Epoch[julian] but it's a solar \
day number by julian not an SI 24hr clock count by TAI.

there is no TAI.m that would give SI days and if there were it would have to:

1) be named differently, maybe TDN
or
2) actually do the work to make TAI a CDN for the moment (do solar \
simulation)

again, the difference in SI days and JDN days is in seconds forgotten at \
solar observance of the new year, which is maybe ? a day every 180 \
years\
\>", "Text"],

Cell["\<\
NewEpochFrom

note 1: if addition is defined calOther can import.  have diff dnd2, it can \
be added to clock only if, ie. jdn is in both epoch, in which case addition \
only works but only coincidentally at that moment.  maybe some library has it \
defined i don't know of one today.  jdn is not necessarily given (or it'd be \
simpler).

note 2: dnd2 is ammt to add to any y of calTo,x,y to be calFrom,x,Y in units \
of y.
note 3: allow dnc2u to see and try all data types not just From types, may \
help
note 4: these are for completeness not really worth effort but. if SI is \
within solar year allow, greg. clock is close enough. lunar is harder. i'd \
hoped for wider span than 1yr for diff types, that's a todo (diff units of \
solar lunar are handled)
note 5: show, if = has been used for Epoch, LHS would be evaluated before \
output.  Put or can output all Epochs in usable form show is the only way to \
get just the one, i think\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["notes for  julian  J  MeanTropicalYear  T", "Subsubsection"],

Cell["\<\
use: est. of effect of precession (earth looses ?1.9 sec every year \
due to nuition) which really depends on where on solar orbit the small angle \
is lost.\
\>", "Text"],

Cell["\<\
directions:
\tunfortunately contants were set up so TT2000.0 is T==0
\tTT ~ J ~ G for this (try and see, TT-J ~ 13 days in 2014)
\tfor julian year 0 that's -J2000 with respect to TT2000\
\>", "Text"],

Cell["\<\
\tthe epoch check is instructive rather than necessary
\ti blow off conversion from TT to J: T^3 and range makes it immesureable \
anyway\
\>", "Text"],

Cell["\<\
important:

julianCentury = 36525 Days (* exactly, of 24*60^2 seconds ea.*)

In astronomy, a julian year (symbol: a) is a unit of measurement of time \
defined as exactly 365.25 days of 86,400 SI seconds

In astronomy the julian calendar is rarely used , it moves unevenly.  \
Instead, ie J2000.0 is used with respect to some epoch (usu. JDN 0) , as \
above time is assumed to flow evenly , and which calendar day anything falls \
on.is DISREGUARDED.

So.  To have an est calendar day for Jnnn.m one must count days from epoch.

assume time flowing evenly as above, others can use conversions if not.\
\>", \
"Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(MeanAnomalisticYear\ 24\ 60^2\)], "Input"],

Cell[BoxData[
    \(3.1558432550399996`*^7\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(FromSeconds2[MeanAnomalisticYear\ 24\ 60^2, anomalistic]\)], "Input"],

Cell[BoxData[
    \({1, 1, 1, 11, 59, 59.99999999508873`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToSeconds2[%, anomalistic]\)], "Input"],

Cell[BoxData[
    \(3.1558432550399993`*^7\)], "Output"]
}, Open  ]],

Cell["\<\
the below uses a calculation for ave year length due to precession \
for julian year 0 and Julian year 2000

don't forget Epoch[TT,TT][[1]]]
\t(how could you it won't run without it as a param)
\tsince epoch is TT 2000, jy 2000 is 0 and jy 0 is -2000
\t(close enough for the equation used)\
\>", "Text"],

Cell["\<\
don't forget T needed is converted from J to JCF
\tT must be in julian centuries
\tthe eq. uses constants so that TT 2000 is 0
\tuse ToCenturyFraction2 is easier here
\t(the JDN tcf uses -4712 as epoch)\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(MeanTropicalYearTTfunc[
        ToCenturyFraction2[{\(-2000\), 1, 1, 0, 0, 0}, julian], julian, 
        Epoch[TT]] - MeanTropicalYearTTfunc[0, julian, Epoch[TT]]\)], "Input"],

Cell[BoxData[
    \(0.00012066827952139647`\)], "Output"]
}, Open  ]],

Cell["\<\
so the rough ave early arrival of spring per year due to precession \
is, in seconds,\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((%/2000)\)\ 365\ 24\ 60^2\)], "Input"],

Cell[BoxData[
    \(1.9026974314933793`\)], "Output"]
}, Open  ]],

Cell["note this has jdn epoch built in", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToCenturyFraction[{36525, 1, 1, 0, 0, 0}, julian] // N\)], "Input"],

Cell[BoxData[
    \(412.37000684462697`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToCenturyFraction2[{36525, 1, 1, 0, 0, 0}, julian] // N\)], "Input"],

Cell[BoxData[
    \(365.25000684462697`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(YearToCenturyFraction[36525, julian] // N\)], "Input"],

Cell[BoxData[
    \(365.25`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(YearFromCenturyFraction[%, julian]\)], "Input"],

Cell[BoxData[
    \(36525.`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DaysFromCenturyFraction[1, julian]\)], "Input"],

Cell[BoxData[
    \(36525\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["epochs  and  TT", "Subsubsection"],

Cell["\<\
from SOFA
\tobservations:
\t\"use TT not UTC or you are a minute off\"
\t\"use time light left object not when observed (ie, JPL data)\"

\tTA1, TT, TCG, are linear to clock TA1
\t\tTCG is time at earth GeoCenter (did they say linear?)
\tUT must be observed at (planet,longitude,latitude,altitude)
\t\tit's complicated to go from past UT dates to today's TT
\t\t(meaning UT observations depending upon where from, line of sight)
\t\t(sofa's C library doesn't do that, jpl horizon webpage might)
\tTT(TAI) = TAI + 32.184 s. TDB==TT- 65.5 \[Micro]s
\tnote J2000.0 does NOT mean julian calendar ! means G2000.5  phhh!

\tTCB TDB (removes,corrects) gravity component said to be part of TCG\
\>", \
"Text"],

Cell["MJD := JD - 2400000.5", "Text"],

Cell["TCG=TT+LG\[Times](JDTT-TT0)", "Text"],

Cell["\<\
wikipedia: \"2443144.5 often cited but 2443144.5003725 fits \
standard exactly\" (if this is so then TT,TAI,gregorian are all equal at that \
time).  due to historical difference between TAI and ET when TT was \
introduced\
\>", "Text"],

Cell["\<\
TAI
\tahead of UTC by 35 sec*
GPS(TAI)=TAI-19
\ttime was zero at 0h 6-Jan-1980
\tahead of UTC by 16 sec*
Loran-C was zero at 0h 1-Jan-1958
\tahead of UTC by 25 sec*
* due to no leap seconds (see below)\
\>", "Text"],

Cell["\<\
USNO says
\tUT ~ GMT colloquially
\tUTC ~ clock adjusted to sun using leapseconds
\tUT1 ~ earth rotation (sidereal?)
\t\t? apparent on celestial sphere ?\
\>", "Text"],

Cell["\<\
leap seconds: average TIDAL deceleration of the Earth ~ 1.4 ms/day. \
today TAI day is about clock 86400.002, about +1 sec per year accumulated \
diff from 24 60 60^2 (SI day)\
\>", "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
what is the old julian calendar layout ?
use of old table\
\>", "Subsection"],

Cell["\<\
\targuably iconic (though not always used if it were) but
\tnot used by Months` (macrobuis sugg. layout)
\t\t! is NOT julian we use today !\
\>", "Text"],

Cell[BoxData[
    \(DayTabOld[
        julian] := \[IndentingNewLine]{{\[IndentingNewLine]{29, 28, 0, 31, 
            29, 31, 29, 31, 29, 29, 31, 29, 29}, \[IndentingNewLine]{29, 28, 
            0, 31, 29, 31, 29, 31, 29, 29, 31, 29, 
            29}, \[IndentingNewLine]{29, 23, 22 + 5, 31, 29, 31, 29, 31, 29, 
            29, 31, 29, 29}, \[IndentingNewLine]{29, 24, 22 + 5, 31, 29, 31, 
            29, 31, 29, 29, 31, 29, 29}, \[IndentingNewLine]{29, 28, 0, 31, 
            29, 31, 29, 31, 29, 29, 31, 29, 29}, \[IndentingNewLine]{29, 28, 
            0, 31, 29, 31, 29, 31, 29, 29, 31, 29, 
            29}, \[IndentingNewLine]{29, 24, 22 + 5, 31, 29, 31, 29, 31, 29, 
            29, 31, 29, 29}, \[IndentingNewLine]{29, 23, 22 + 5, 31, 29, 31, 
            29, 31, 29, 29, 31, 29, 
            29}\[IndentingNewLine]}, \
\[IndentingNewLine]{\[IndentingNewLine]{29, 28, 0, 31, 29, 31, 29, 31, 29, 
            29, 31, 29, 29}, \[IndentingNewLine]{29, 28, 0, 31, 29, 31, 29, 
            31, 29, 29, 31, 29, 29}, \[IndentingNewLine]{29, 28, 0, 31, 29, 
            31, 29, 31, 29, 29, 31, 29, 29}, \[IndentingNewLine]{29, 23, 
            22 + 5, 31, 29, 31, 29, 31, 29, 29, 31, 29, 
            29}, \[IndentingNewLine]{29, 28, 0, 31, 29, 31, 29, 31, 29, 29, 
            31, 29, 29}, \[IndentingNewLine]{29, 28, 0, 31, 29, 31, 29, 31, 
            29, 29, 31, 29, 29}, \[IndentingNewLine]{29, 23, 22 + 5, 31, 29, 
            31, 29, 31, 29, 29, 31, 29, 29}, \[IndentingNewLine]{29, 23, 
            22 + 5, 31, 29, 31, 29, 31, 29, 29, 31, 29, 
            29}\[IndentingNewLine]}}\)], "Input",
  Evaluatable->False,
  InitializationCell->True],

Cell[BoxData[
    \(MonthTabOld[year_?NumericQ, 
        julian] := \[IndentingNewLine]\(DayTab[
          julian]\)[\([\[IndentingNewLine]If[Mod[y, 24] \[LessEqual] 16, 1, 
            2], \[IndentingNewLine]Mod[y, 8] + 
            1\[IndentingNewLine]]\)]\)], "Input",
  Evaluatable->False,
  InitializationCell->True],

Cell[BoxData[
    \(MonthTabOld[{year_, ___}, julian] := MonthTab[year, julian]\)], "Input",\

  Evaluatable->False,
  InitializationCell->True],

Cell[BoxData[
    \(MonthTabOld[year_?NumericQ, julian] := 
      Module[{M}, 
        Table[DaysInMonth[Floor@year, M, julian], {M, 1, 
            MonthsInYear[julian]}]]\)], "Input",
  Evaluatable->False,
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["lack of tests  julian", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Do[\[IndentingNewLine]If[
        Plus @@ Table[DaysInMonth[j, i, julian], {i, 1, 12}] =!= 
          DaysInYear[j, julian], \[IndentingNewLine]Print@{"\<hole\>", j, 
            DaysInYear[j, julian], 
            Plus @@ Table[
                DaysInMonth[j, i, julian], {i, 1, 
                  12}]}\[IndentingNewLine]]; \[IndentingNewLine]If[
        Mod[j, 1000] === 0, Print@{j}], \[IndentingNewLine]{j, 1, 
        2000}]\)], "Input",
  Evaluatable->True],

Cell[BoxData[
    \({1000}\)], "Print"],

Cell[BoxData[
    \({2000}\)], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Date[]\)], "Input"],

Cell[BoxData[
    \({2014, 6, 22, 23, 20, 8}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom[{\(-4712\), 1, 1, 12, 0, 0}, julian, julian]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plus @@ Table[DaysInMonth[400, i, julian], {i, 1, 12}]\)], "Input"],

Cell[BoxData[
    \(366\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DaysInYear[400, julian]\)], "Input"],

Cell[BoxData[
    \(366\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom[Date[], gregorian, julian]\)], "Input"],

Cell[BoxData[
    \(212270239253\/86400\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberTo[%, julian] - Date[]\)], "Input"],

Cell[BoxData[
    \({0, 0, \(-13\), 0, 0, 0}\)], "Output"]
}, Open  ]],

Cell["{0,0,13,0,0,1} ", "Text"],

Cell["\<\
Table[{DayNumberTo[i],i,DayNumberFrom[DayNumberTo[i]]}//Flatten,{i,-\
400,400}]//TableForm\
\>", "Text"],

Cell["these were tested to +- 10k", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Do[If[
          i \[NotEqual] 
            DayNumberFrom[DayNumberTo[i, gregorian, julian], gregorian, 
              julian], 
          Return@{i, 
              DayNumberFrom[DayNumberTo[i, gregorian, julian], gregorian, 
                julian]}], {i, \(-1000\), 1000}] \[Equal] Null\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Do[If[i \[NotEqual] DayNumberFrom[DayNumberTo[i]], 
          Return@{i, DayNumberFrom[DayNumberTo[i]]}], {i, \(-1000\), 
          1000}] \[Equal] Null\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell["ToCenturyFraction is T for MeanTropicalYear[T]", "Text"],

Cell["show preservation of arbitrary form and fraction form //N", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToCenturyFraction[Date[]] // InputForm\)], "Input"],

Cell["53067840617/788940000", "Output"]
}, Open  ]],

Cell["-4712/36525", "Text"],

Cell["\<\
before cent. frac during debug
-0.12900752908966462` \
\>", "Text"],

Cell["note the below shouldn't have precision set, mm ...", "Text"],

Cell["NOTE the below should be 1/2 day short", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(ToCenturyFraction[{\(-4712\), 12, 31, 23, 59, 59}, julian] // 
        InputForm\) // N\)], "Input"],

Cell["0.010006844310086953", "Output"]
}, Open  ]],

Cell["0.010006844310086953", "Text"],

Cell["-0.129034870194337` ", "Text"],

Cell["from julian year 0 instead is", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(ToCenturyFraction2[{\(-4712\), 12, 31, 23, 59, 59}, julian] // 
        InputForm\) // N\)], "Input"],

Cell["-47.109993155689914", "Output"]
}, Open  ]],

Cell["\<\
\ti thought so: alg. does not use 355 or 377,378 calendar, oh \
well...\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Table[MonthDays[\(-4712\), i, julian], {i, 0, 13}]\)], "Input"],

Cell[BoxData[
    \({0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335, 366, 
      MonthDays[\(-4712\), 13, julian]}\)], "Output"]
}, Open  ]],

Cell["\<\
{0,31,60,91,121,152,182,213,244,274,305,335,366,MonthDaysjulian[-\
4712,13]} \
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberDifference[{\(-4711\), 1, 1, 12, 0, 0}, {\(-4712\), 1, 1, 12, 
        0, 0}]\)], "Input"],

Cell[BoxData[
    \(\(-366\)\)], "Output"]
}, Open  ]],

Cell["366", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(MonthDays[2012, 0, julian]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell["\tis apparently a mix of 365,366 with 364 infrequenty", "Text"],

Cell["\<\
Table[JDNdiff[{-4712-i+1,1,1,12,0,0},{-4712-i,1,1,12,0,0},False],{i,\
1,1000}]\
\>", "Text"],

Cell["\<\
this is worth noting.  mm's answer isn't possible: JDN starts at 12 \
it must be 1/2 off.  i think values are 1/2 diff.\
\>", "Text"],

Cell["\<\
this is incorrect it because day number is not same between \
calendars\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberDifference[Epoch[FromDate, gregorian, date], 
      Epoch[julianDayNumber, gregorian, date], julian]\)], "Input"],

Cell[BoxData[
    \(\(-\(4830141\/2\)\)\)], "Output"]
}, Open  ]],

Cell["so use conversion if args must match units", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberDifference[\[IndentingNewLine]gregorianTojulian@
          Epoch[FromDate, gregorian, date], 
        gregorianTojulian@Epoch[julianDayNumber, gregorian, date], julian] // 
      Rationalize\)], "Input"],

Cell[BoxData[
    \(\(-\(4830041\/2\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberDifference2[
        Epoch[FromDate, gregorian, date] // gregorianTojulian, 
        Epoch[julianDayNumber, julian, date]] // N\)], "Input"],

Cell[BoxData[
    \(\(-2.4150205`*^6\)\)], "Output"]
}, Open  ]],

Cell["2.4149825`*^6 ", "Text"],

Cell["-2415033", "Text"],

Cell["-----------------", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Needs["\<Miscellaneous`Calendar`\>"]\)], "Input"],

Cell[BoxData[
    \(Sunday::"shdw" \(\(:\)\(\ \)\) 
      "Symbol \!\(\"Sunday\"\) appears in multiple contexts \
\!\({\"Miscellaneous`Calendar`\", \"Months`Common`MonthsCommon`\"}\); \
definitions in context \!\(\"Miscellaneous`Calendar`\"\) may shadow or be \
shadowed by other definitions."\)], "Message"],

Cell[BoxData[
    \(Monday::"shdw" \(\(:\)\(\ \)\) 
      "Symbol \!\(\"Monday\"\) appears in multiple contexts \
\!\({\"Miscellaneous`Calendar`\", \"Months`Common`MonthsCommon`\"}\); \
definitions in context \!\(\"Miscellaneous`Calendar`\"\) may shadow or be \
shadowed by other definitions."\)], "Message"],

Cell[BoxData[
    \(Tuesday::"shdw" \(\(:\)\(\ \)\) 
      "Symbol \!\(\"Tuesday\"\) appears in multiple contexts \
\!\({\"Miscellaneous`Calendar`\", \"Months`Common`MonthsCommon`\"}\); \
definitions in context \!\(\"Miscellaneous`Calendar`\"\) may shadow or be \
shadowed by other definitions."\)], "Message"],

Cell[BoxData[
    \(Wednesday::"shdw" \(\(:\)\(\ \)\) 
      "Symbol \!\(\"Wednesday\"\) appears in multiple contexts \
\!\({\"Miscellaneous`Calendar`\", \"Months`Common`MonthsCommon`\"}\); \
definitions in context \!\(\"Miscellaneous`Calendar`\"\) may shadow or be \
shadowed by other definitions."\)], "Message"],

Cell[BoxData[
    \(Thursday::"shdw" \(\(:\)\(\ \)\) 
      "Symbol \!\(\"Thursday\"\) appears in multiple contexts \
\!\({\"Miscellaneous`Calendar`\", \"Months`Common`MonthsCommon`\"}\); \
definitions in context \!\(\"Miscellaneous`Calendar`\"\) may shadow or be \
shadowed by other definitions."\)], "Message"],

Cell[BoxData[
    \(Friday::"shdw" \(\(:\)\(\ \)\) 
      "Symbol \!\(\"Friday\"\) appears in multiple contexts \
\!\({\"Miscellaneous`Calendar`\", \"Months`Common`MonthsCommon`\"}\); \
definitions in context \!\(\"Miscellaneous`Calendar`\"\) may shadow or be \
shadowed by other definitions."\)], "Message"],

Cell[BoxData[
    \(Saturday::"shdw" \(\(:\)\(\ \)\) 
      "Symbol \!\(\"Saturday\"\) appears in multiple contexts \
\!\({\"Miscellaneous`Calendar`\", \"Months`Common`MonthsCommon`\"}\); \
definitions in context \!\(\"Miscellaneous`Calendar`\"\) may shadow or be \
shadowed by other definitions."\)], "Message"]
}, Open  ]],

Cell[BoxData[
    \(CalendarChange[{0, 1, 1, 12, 0, 0}, Gregorian, Julian]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom[{0, 1, 1, 12, 0, 0}] - DayNumberFrom[0]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell["\<\
\twhen converting keep in mind start of day isn't same for \
both\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberFrom[{0, 1, 1, 12, 0, 0}, gregorian, julian] - 
      DayNumberFrom[{0, 1, 1, 12, 0, 0}]\)], "Input"],

Cell[BoxData[
    \(2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DayNumberDifference[Epoch[julianDayNumber, julian, date], 
        gregorianTojulian@Epoch[FromDate, gregorian, date]] // 
      Rationalize\)], "Input"],

Cell[BoxData[
    \(4830041\/2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Table[{leapdays[
          j], \((Sign@j\ Plus @@ 
              Table[If[IsLeapYear[i], 1, 0], {i, 0, j, 
                  Sign@j}])\)}, {j, \(-1000\), 1000, 74}]\)], "Input"],

Cell[BoxData[
    \({{\(-242\), \(-243\)}, {\(-224\), \(-225\)}, {\(-207\), \(-208\)}, \
{\(-188\), \(-189\)}, {\(-170\), \(-171\)}, {\(-152\), \(-153\)}, {\(-135\), \
\(-136\)}, {\(-117\), \(-118\)}, {\(-99\), \(-100\)}, {\(-80\), \(-81\)}, \
{\(-63\), \(-64\)}, {\(-45\), \(-46\)}, {\(-27\), \(-28\)}, {\(-9\), \
\(-10\)}, {10, 10}, {27, 27}, {46, 46}, {63, 63}, {81, 81}, {99, 99}, {118, 
        118}, {135, 135}, {153, 153}, {170, 170}, {189, 189}, {207, 
        207}, {225, 225}, {243, 243}}\)], "Output"]
}, Open  ]],

Cell["\t0 is a leap year", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(leapdays[0]\)], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["anomalistic , synodic and lunisolar", "Subsection"],

Cell["\<\
\tanomalistic uses anomalistic year
\t\tave trip around sun, more stable than seasonal
\t\t\texhibits a .m using NO LEAPS
\t\thasn't been used / tested hardly
\tsynodic
\t\tit is NOT precise at new moon telling
\t\tit only uses average, roughly good years forward and back
\tsynodicEpochDaysUT moon formula
\t\ti got off wikipedia, hardly better than synodic sorry
\t\texhibits use a formula by JDN only
\tsquared is like synodicEpochDaysUT
\t\tbut wrapped in Months to conform / use epoch / etc
\t\texhibits use of formula w/in calendar wrap\t\t\
\>", "Text"],

Cell["\<\
old lunar calendars assume 235 new moons == 19 years (guess what, \
it isn't).  354.n days / yr (two moons) and 384 (3 moons) on leaps to catch \
up seasonal year.  ah but 384-354 isn't one moon orbit it'd be fraction.  \
many are religiously adjusted.  from a math perspective it makes no sense to \
try to emulate.\
\>", "Text"],

Cell[CellGroupData[{

Cell["calTransform  From  To", "Subsubsection"],

Cell["\<\
\tcalTransform To,From [days, cal]

\t\tallow two custom function to work as if calendar
\t\t(a function and it's inverse for working to/from)

\t\treason: while not being calendarizeable
\t\tcan still be compared to and from cal dates, JDN, etc

\t\ta last minute thought after trying synodic
\t\tone could not define YearDay etc in a cal.m and
\t\t\t(or could do that as well)
\t\tinstead define a function for mapping a non-linear way
\t\t{0,1,1,0,0,0}-> day number 0, ctf can subst it's own val
\t\tthen for cft day number 0-> day 1 and ctf gets subst
\t\tjust before 1 -> {0,1,1,0,0,0}
\t\t
\t\t( errata on partially defining a cal.m:
\t\tfor that readson DayNumber2 doesn't assume Month things are
\t\tdefine for prospective calendar UNLESS it, ie, uses Year
\t\tin any way then it must provide leapdays[y,cal] even if always 0.
\t\twhile Month use is optional for both.
\t\tepochs are used of course, and fixdate[dt,cal] must be defined )

\t\tanother way might be provide override functions
\t\t\tDayNumberFrom2[x_,q,q]:=...
\t\t\tDayNumberTo2[x_,q,q]:=...
\t\twhich shouldn't be necessary\
\>", "Text"],

Cell["\<\
ERRATA
\tepoch is not date of new moon
\t\tis where fuction thinks 0 days is
\t\tnote daystart won't work unless functions reverse it
\tconvenient to use epoch as this because
\t\tworks INDIRECTLY like synodic From/To Days
\t\tdate 0 -> days till 1st moon, days till 1st -> day 0
\t\tless or no \"specialty needs\" in function itself\
\>", "Text"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
AutoGeneratedPackage->None,
WindowSize->{686, 579},
WindowMargins->{{81, Automatic}, {-27, Automatic}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 29, 0, 42, "Subsubsection"],
Cell[1771, 53, 294, 5, 65, "Text"],
Cell[2068, 60, 45, 0, 31, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2150, 65, 53, 0, 60, "Section"],
Cell[2206, 67, 592, 12, 184, "Text"],
Cell[2801, 81, 507, 10, 100, "Text"],
Cell[3311, 93, 175, 4, 48, "Text"],

Cell[CellGroupData[{
Cell[3511, 101, 64, 0, 45, "Subsection"],
Cell[3578, 103, 1097, 17, 338, "Text"],

Cell[CellGroupData[{
Cell[4700, 124, 132, 2, 56, "Input"],
Cell[4835, 128, 49, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4921, 134, 68, 1, 40, "Input"],
Cell[4992, 137, 44, 1, 40, "Output"]
}, Open  ]],
Cell[5051, 141, 163, 4, 48, "Text"],

Cell[CellGroupData[{
Cell[5239, 149, 62, 1, 40, "Input"],
Cell[5304, 152, 50, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5391, 158, 42, 1, 40, "Input"],
Cell[5436, 161, 59, 1, 40, "Output"]
}, Open  ]],
Cell[5510, 165, 48, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[5583, 169, 62, 1, 40, "Input"],
Cell[5648, 172, 50, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5735, 178, 47, 1, 40, "Input"],
Cell[5785, 181, 53, 1, 40, "Output"]
}, Open  ]],
Cell[5853, 185, 524, 10, 185, "Text"],
Cell[6380, 197, 548, 10, 150, "Text"],
Cell[6931, 209, 192, 4, 48, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7160, 218, 69, 0, 45, "Subsection"],
Cell[7232, 220, 1418, 31, 507, "Text"],
Cell[8653, 253, 585, 12, 201, "Text"],
Cell[9241, 267, 537, 8, 116, "Text"],
Cell[9781, 277, 1677, 32, 490, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11495, 314, 55, 0, 45, "Subsection"],
Cell[11553, 316, 296, 7, 66, "Text"],
Cell[11852, 325, 458, 7, 116, "Text"],
Cell[12313, 334, 246, 5, 65, "Text"],
Cell[12562, 341, 260, 5, 65, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12859, 351, 45, 0, 45, "Subsection"],
Cell[12907, 353, 50, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[12982, 358, 51, 1, 27, "Input"],
Cell[13036, 361, 158, 2, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13231, 368, 46, 1, 27, "Input"],
Cell[13280, 371, 127, 2, 23, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13444, 378, 56, 1, 27, "Input"],
Cell[13503, 381, 55, 1, 23, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13595, 387, 53, 1, 27, "Input"],
Cell[13651, 390, 200, 5, 53, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13888, 400, 60, 1, 27, "Input"],
Cell[13951, 403, 145, 3, 23, "Message"]
}, Open  ]],
Cell[14111, 409, 47, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[14183, 413, 58, 1, 27, "Input"],
Cell[14244, 416, 109, 3, 23, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14390, 424, 46, 1, 27, "Input"],
Cell[14439, 427, 72, 1, 23, "Print"],
Cell[14514, 430, 1288, 30, 218, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15839, 465, 62, 1, 27, "Input"],
Cell[15904, 468, 91, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16032, 474, 47, 1, 27, "Input"],
Cell[16082, 477, 89, 1, 23, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[16220, 484, 46, 0, 45, "Subsection"],
Cell[16269, 486, 31, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[16325, 490, 42, 1, 27, "Input"],
Cell[16370, 493, 190, 3, 39, "Print"],
Cell[16563, 498, 480, 13, 23, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[17080, 516, 51, 1, 27, "Input"],
Cell[17134, 519, 158, 2, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[17329, 526, 54, 1, 27, "Input"],
Cell[17386, 529, 139, 2, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[17562, 536, 46, 1, 27, "Input"],
Cell[17611, 539, 72, 1, 23, "Print"],
Cell[17686, 542, 1236, 28, 218, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18959, 575, 54, 1, 40, "Input"],
Cell[19016, 578, 42, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19095, 584, 70, 1, 40, "Input"],
Cell[19168, 587, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19240, 593, 90, 1, 40, "Input"],
Cell[19333, 596, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19405, 602, 88, 1, 40, "Input"],
Cell[19496, 605, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19568, 611, 64, 1, 40, "Input"],
Cell[19635, 614, 37, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19709, 620, 70, 1, 40, "Input"],
Cell[19782, 623, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19854, 629, 72, 1, 40, "Input"],
Cell[19929, 632, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20001, 638, 70, 1, 40, "Input"],
Cell[20074, 641, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20146, 647, 70, 1, 40, "Input"],
Cell[20219, 650, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20291, 656, 72, 1, 40, "Input"],
Cell[20366, 659, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20438, 665, 72, 1, 40, "Input"],
Cell[20513, 668, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20585, 674, 70, 1, 40, "Input"],
Cell[20658, 677, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20730, 683, 51, 1, 27, "Input"],
Cell[20784, 686, 64, 1, 23, "Print"],
Cell[20851, 689, 1146, 26, 218, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22034, 720, 50, 1, 27, "Input"],
Cell[22087, 723, 119, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22243, 730, 52, 1, 27, "Input"],
Cell[22298, 733, 163, 2, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22498, 740, 74, 1, 40, "Input"],
Cell[22575, 743, 43, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22655, 749, 88, 1, 40, "Input"],
Cell[22746, 752, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22818, 758, 51, 1, 40, "Input"],
Cell[22872, 761, 89, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22998, 767, 54, 1, 40, "Input"],
Cell[23055, 770, 90, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[23182, 776, 45, 1, 40, "Input"],
Cell[23230, 779, 90, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[23357, 785, 62, 1, 40, "Input"],
Cell[23422, 788, 90, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[23549, 794, 80, 1, 40, "Input"],
Cell[23632, 797, 44, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[23713, 803, 51, 1, 40, "Input"],
Cell[23767, 806, 93, 1, 40, "Output"]
}, Open  ]],
Cell[23875, 810, 58, 0, 31, "Text"],
Cell[23936, 812, 61, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[24022, 816, 145, 2, 56, "Input"],
Cell[24170, 820, 47, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[24254, 826, 134, 2, 56, "Input"],
Cell[24391, 830, 45, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[24473, 836, 134, 2, 56, "Input"],
Cell[24610, 840, 45, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[24692, 846, 67, 1, 40, "Input"],
Cell[24762, 849, 55, 1, 40, "Output"]
}, Open  ]],
Cell[24832, 853, 46, 1, 40, "Input"],
Cell[24881, 856, 76, 1, 40, "Input"],
Cell[24960, 859, 93, 1, 40, "Input"],

Cell[CellGroupData[{
Cell[25078, 864, 90, 1, 40, "Input"],
Cell[25171, 867, 59, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[25267, 873, 79, 1, 40, "Input"],
Cell[25349, 876, 40, 1, 40, "Output"]
}, Open  ]],
Cell[25404, 880, 76, 1, 40, "Input"],

Cell[CellGroupData[{
Cell[25505, 885, 76, 1, 40, "Input"],
Cell[25584, 888, 40, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[25661, 894, 80, 1, 40, "Input"],
Cell[25744, 897, 42, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[25823, 903, 119, 2, 40, "Input",
  InitializationCell->True],
Cell[25945, 907, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[26017, 913, 88, 1, 40, "Input"],
Cell[26108, 916, 55, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[26200, 922, 79, 1, 40, "Input"],
Cell[26282, 925, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[26354, 931, 79, 1, 40, "Input"],
Cell[26436, 934, 35, 1, 40, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[26520, 941, 35, 0, 45, "Subsection"],
Cell[26558, 943, 198, 4, 48, "Text"],
Cell[26759, 949, 48, 1, 40, "Input"],
Cell[26810, 952, 132, 2, 56, "Input"],

Cell[CellGroupData[{
Cell[26967, 958, 76, 1, 40, "Input"],
Cell[27046, 961, 58, 1, 40, "Output"]
}, Open  ]],
Cell[27119, 965, 73, 1, 40, "Input"],

Cell[CellGroupData[{
Cell[27217, 970, 76, 1, 40, "Input"],
Cell[27296, 973, 58, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27391, 979, 92, 1, 40, "Input"],
Cell[27486, 982, 179, 3, 39, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27702, 990, 76, 1, 40, "Input"],
Cell[27781, 993, 58, 1, 40, "Output"]
}, Open  ]],
Cell[27854, 997, 52, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[27931, 1001, 75, 1, 40, "Input"],
Cell[28009, 1004, 58, 1, 40, "Output"]
}, Open  ]],
Cell[28082, 1008, 278, 7, 116, "Text"],
Cell[28363, 1017, 73, 1, 40, "Input"],

Cell[CellGroupData[{
Cell[28461, 1022, 66, 1, 40, "Input"],
Cell[28530, 1025, 58, 1, 40, "Output"]
}, Open  ]],
Cell[28603, 1029, 83, 1, 40, "Input"],

Cell[CellGroupData[{
Cell[28711, 1034, 179, 3, 56, "Input"],
Cell[28893, 1039, 38, 1, 40, "Output"]
}, Open  ]],
Cell[28946, 1043, 76, 0, 31, "Text"],
Cell[29025, 1045, 51, 1, 40, "Input"],
Cell[29079, 1048, 47, 0, 31, "Text"],
Cell[29129, 1050, 548, 12, 184, "Text"],
Cell[29680, 1064, 592, 12, 184, "Text"],
Cell[30275, 1078, 164, 4, 48, "Text"],
Cell[30442, 1084, 173, 4, 48, "Text"],
Cell[30618, 1090, 269, 7, 116, "Text"],
Cell[30890, 1099, 30, 0, 31, "Text"],
Cell[30923, 1101, 207, 6, 82, "Text"],
Cell[31133, 1109, 40, 0, 31, "Text"],
Cell[31176, 1111, 28, 0, 31, "Text"],
Cell[31207, 1113, 1604, 30, 422, "Text"],
Cell[32814, 1145, 958, 17, 269, "Text"],
Cell[33775, 1164, 74, 1, 27, "Input"],
Cell[33852, 1167, 135, 3, 48, "Text"],

Cell[CellGroupData[{
Cell[34012, 1174, 93, 1, 27, "Input"],
Cell[34108, 1177, 52, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[34197, 1183, 70, 1, 40, "Input"],
Cell[34270, 1186, 67, 1, 40, "Output"]
}, Open  ]],
Cell[34352, 1190, 387, 7, 123, "Input"],
Cell[34742, 1199, 46, 1, 27, "Input"],
Cell[34791, 1202, 408, 7, 123, "Input"],
Cell[35202, 1211, 46, 1, 27, "Input"],
Cell[35251, 1214, 52, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[35328, 1218, 71, 1, 27, "Input"],
Cell[35402, 1221, 71, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[35510, 1227, 66, 1, 27, "Input"],
Cell[35579, 1230, 59, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[35675, 1236, 64, 1, 27, "Input"],
Cell[35742, 1239, 71, 1, 27, "Output"]
}, Open  ]],
Cell[35828, 1243, 358, 6, 123, "Input"],
Cell[36189, 1251, 46, 1, 27, "Input"],
Cell[36238, 1254, 362, 6, 107, "Input"],
Cell[36603, 1262, 46, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[36674, 1267, 91, 1, 40, "Input"],
Cell[36768, 1270, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[36840, 1276, 84, 1, 40, "Input"],
Cell[36927, 1279, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[36999, 1285, 108, 2, 40, "Input"],
Cell[37110, 1289, 42, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37189, 1295, 109, 2, 40, "Input"],
Cell[37301, 1299, 46, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37384, 1305, 103, 2, 40, "Input"],
Cell[37490, 1309, 46, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37573, 1315, 147, 2, 56, "Input"],
Cell[37723, 1319, 53, 1, 57, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37813, 1325, 155, 3, 56, "Input"],
Cell[37971, 1330, 52, 1, 57, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[38060, 1336, 91, 1, 40, "Input"],
Cell[38154, 1339, 52, 1, 57, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[38243, 1345, 39, 1, 40, "Input"],
Cell[38285, 1348, 35, 1, 40, "Output"]
}, Open  ]],
Cell[38335, 1352, 274, 7, 116, "Text"],

Cell[CellGroupData[{
Cell[38634, 1363, 160, 3, 56, "Input"],
Cell[38797, 1368, 37, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[38871, 1374, 103, 2, 40, "Input"],
Cell[38977, 1378, 37, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[39051, 1384, 111, 2, 40, "Input"],
Cell[39165, 1388, 42, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[39244, 1394, 91, 1, 40, "Input"],
Cell[39338, 1397, 42, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[39417, 1403, 39, 1, 40, "Input"],
Cell[39459, 1406, 35, 1, 40, "Output"]
}, Open  ]],
Cell[39509, 1410, 197, 4, 48, "Text"],

Cell[CellGroupData[{
Cell[39731, 1418, 134, 2, 56, "Input"],
Cell[39868, 1422, 41, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[39946, 1428, 71, 1, 40, "Input"],
Cell[40020, 1431, 38, 1, 57, "Output"]
}, Open  ]],
Cell[40073, 1435, 41, 1, 40, "Input"],

Cell[CellGroupData[{
Cell[40139, 1440, 43, 1, 40, "Input"],
Cell[40185, 1443, 59, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[40281, 1449, 52, 1, 40, "Input"],
Cell[40336, 1452, 58, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[40431, 1458, 70, 1, 40, "Input"],
Cell[40504, 1461, 58, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[40599, 1467, 70, 1, 40, "Input"],
Cell[40672, 1470, 59, 1, 40, "Output"]
}, Open  ]],
Cell[40746, 1474, 71, 1, 40, "Input"],

Cell[CellGroupData[{
Cell[40842, 1479, 52, 1, 40, "Input"],
Cell[40897, 1482, 61, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[40995, 1488, 70, 1, 40, "Input"],
Cell[41068, 1491, 61, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[41166, 1497, 70, 1, 40, "Input"],
Cell[41239, 1500, 63, 1, 40, "Output"]
}, Open  ]],
Cell[41317, 1504, 41, 1, 40, "Input"],
Cell[41361, 1507, 26, 0, 31, "Text"],
Cell[41390, 1509, 252, 6, 99, "Text"],
Cell[41645, 1517, 319, 11, 184, "Text"],
Cell[41967, 1530, 216, 4, 65, "Text"],
Cell[42186, 1536, 964, 27, 439, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[43187, 1568, 63, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[43275, 1572, 42, 0, 42, "Subsubsection"],
Cell[43320, 1574, 76, 0, 31, "Text"],
Cell[43399, 1576, 187, 4, 48, "Text"],
Cell[43589, 1582, 227, 6, 82, "Text"],
Cell[43819, 1590, 401, 10, 150, "Text"],
Cell[44223, 1602, 259, 5, 65, "Text"],
Cell[44485, 1609, 361, 9, 133, "Text"],
Cell[44849, 1620, 1217, 19, 287, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[46103, 1644, 45, 0, 42, "Subsubsection"],
Cell[46151, 1646, 253, 9, 133, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[46441, 1660, 33, 0, 42, "Subsubsection"],
Cell[46477, 1662, 358, 9, 133, "Text"],
Cell[46838, 1673, 460, 10, 150, "Text"],
Cell[47301, 1685, 530, 16, 235, "Text"],
Cell[47834, 1703, 965, 20, 269, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[48836, 1728, 66, 0, 42, "Subsubsection"],
Cell[48905, 1730, 181, 4, 48, "Text"],
Cell[49089, 1736, 209, 5, 82, "Text"],
Cell[49301, 1743, 161, 4, 48, "Text"],
Cell[49465, 1749, 626, 17, 252, "Text"],

Cell[CellGroupData[{
Cell[50116, 1770, 62, 1, 40, "Input"],
Cell[50181, 1773, 56, 1, 42, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[50274, 1779, 89, 1, 40, "Input"],
Cell[50366, 1782, 71, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[50474, 1788, 59, 1, 40, "Input"],
Cell[50536, 1791, 56, 1, 42, "Output"]
}, Open  ]],
Cell[50607, 1795, 313, 8, 133, "Text"],
Cell[50923, 1805, 226, 6, 99, "Text"],

Cell[CellGroupData[{
Cell[51174, 1815, 195, 3, 56, "Input"],
Cell[51372, 1820, 57, 1, 40, "Output"]
}, Open  ]],
Cell[51444, 1824, 109, 3, 31, "Text"],

Cell[CellGroupData[{
Cell[51578, 1831, 60, 1, 40, "Input"],
Cell[51641, 1834, 53, 1, 40, "Output"]
}, Open  ]],
Cell[51709, 1838, 48, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[51782, 1842, 87, 1, 40, "Input"],
Cell[51872, 1845, 53, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[51962, 1851, 88, 1, 40, "Input"],
Cell[52053, 1854, 53, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[52143, 1860, 74, 1, 40, "Input"],
Cell[52220, 1863, 41, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[52298, 1869, 67, 1, 40, "Input"],
Cell[52368, 1872, 41, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[52446, 1878, 67, 1, 40, "Input"],
Cell[52516, 1881, 39, 1, 40, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[52604, 1888, 40, 0, 42, "Subsubsection"],
Cell[52647, 1890, 711, 17, 269, "Text"],
Cell[53361, 1909, 37, 0, 31, "Text"],
Cell[53401, 1911, 43, 0, 31, "Text"],
Cell[53447, 1913, 246, 5, 65, "Text"],
Cell[53696, 1920, 225, 9, 150, "Text"],
Cell[53924, 1931, 177, 6, 99, "Text"],
Cell[54104, 1939, 199, 4, 48, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[54352, 1949, 87, 3, 62, "Subsection"],
Cell[54442, 1954, 163, 4, 65, "Text"],
Cell[54608, 1960, 1655, 26, 347, "Input",
  Evaluatable->False,
  InitializationCell->True],
Cell[56266, 1988, 321, 7, 91, "Input",
  Evaluatable->False,
  InitializationCell->True],
Cell[56590, 1997, 144, 4, 27, "Input",
  Evaluatable->False,
  InitializationCell->True],
Cell[56737, 2003, 235, 6, 43, "Input",
  Evaluatable->False,
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[57009, 2014, 43, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[57077, 2018, 484, 10, 136, "Input",
  Evaluatable->True],
Cell[57564, 2030, 39, 1, 23, "Print"],
Cell[57606, 2033, 39, 1, 23, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[57682, 2039, 39, 1, 40, "Input"],
Cell[57724, 2042, 58, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[57819, 2048, 91, 1, 40, "Input"],
Cell[57913, 2051, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[57985, 2057, 87, 1, 40, "Input"],
Cell[58075, 2060, 37, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[58149, 2066, 56, 1, 40, "Input"],
Cell[58208, 2069, 37, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[58282, 2075, 73, 1, 40, "Input"],
Cell[58358, 2078, 53, 1, 57, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[58448, 2084, 64, 1, 40, "Input"],
Cell[58515, 2087, 58, 1, 40, "Output"]
}, Open  ]],
Cell[58588, 2091, 31, 0, 31, "Text"],
Cell[58622, 2093, 114, 3, 31, "Text"],
Cell[58739, 2098, 43, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[58807, 2102, 321, 7, 72, "Input"],
Cell[59131, 2111, 38, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[59206, 2117, 185, 3, 56, "Input"],
Cell[59394, 2122, 38, 1, 40, "Output"]
}, Open  ]],
Cell[59447, 2126, 62, 0, 31, "Text"],
Cell[59512, 2128, 73, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[59610, 2132, 71, 1, 40, "Input"],
Cell[59684, 2135, 39, 0, 40, "Output"]
}, Open  ]],
Cell[59738, 2138, 27, 0, 31, "Text"],
Cell[59768, 2140, 77, 3, 48, "Text"],
Cell[59848, 2145, 67, 0, 31, "Text"],
Cell[59918, 2147, 54, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[59997, 2151, 122, 2, 40, "Input"],
Cell[60122, 2155, 38, 0, 40, "Output"]
}, Open  ]],
Cell[60175, 2158, 36, 0, 31, "Text"],
Cell[60214, 2160, 36, 0, 31, "Text"],
Cell[60253, 2162, 45, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[60323, 2166, 123, 2, 40, "Input"],
Cell[60449, 2170, 37, 0, 40, "Output"]
}, Open  ]],
Cell[60501, 2173, 95, 3, 31, "Text"],

Cell[CellGroupData[{
Cell[60621, 2180, 83, 1, 40, "Input"],
Cell[60707, 2183, 135, 2, 56, "Output"]
}, Open  ]],
Cell[60857, 2188, 101, 3, 31, "Text"],

Cell[CellGroupData[{
Cell[60983, 2195, 119, 2, 40, "Input"],
Cell[61105, 2199, 42, 1, 40, "Output"]
}, Open  ]],
Cell[61162, 2203, 19, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[61206, 2207, 59, 1, 40, "Input"],
Cell[61268, 2210, 35, 1, 40, "Output"]
}, Open  ]],
Cell[61318, 2214, 69, 0, 31, "Text"],
Cell[61390, 2216, 102, 3, 31, "Text"],
Cell[61495, 2221, 143, 3, 48, "Text"],
Cell[61641, 2226, 95, 3, 31, "Text"],

Cell[CellGroupData[{
Cell[61761, 2233, 142, 2, 56, "Input"],
Cell[61906, 2237, 53, 1, 57, "Output"]
}, Open  ]],
Cell[61974, 2241, 58, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[62057, 2245, 232, 4, 88, "Input"],
Cell[62292, 2251, 53, 1, 57, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[62382, 2257, 169, 3, 56, "Input"],
Cell[62554, 2262, 52, 1, 42, "Output"]
}, Open  ]],
Cell[62621, 2266, 30, 0, 31, "Text"],
Cell[62654, 2268, 24, 0, 31, "Text"],
Cell[62681, 2270, 33, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[62739, 2274, 69, 1, 27, "Input"],
Cell[62811, 2277, 308, 5, 55, "Message"],
Cell[63122, 2284, 308, 5, 55, "Message"],
Cell[63433, 2291, 310, 5, 55, "Message"],
Cell[63746, 2298, 314, 5, 55, "Message"],
Cell[64063, 2305, 312, 5, 55, "Message"],
Cell[64378, 2312, 308, 5, 55, "Message"],
Cell[64689, 2319, 312, 5, 55, "Message"]
}, Open  ]],
Cell[65016, 2327, 87, 1, 40, "Input"],

Cell[CellGroupData[{
Cell[65128, 2332, 86, 1, 40, "Input"],
Cell[65217, 2335, 35, 1, 40, "Output"]
}, Open  ]],
Cell[65267, 2339, 89, 3, 31, "Text"],

Cell[CellGroupData[{
Cell[65381, 2346, 130, 2, 40, "Input"],
Cell[65514, 2350, 35, 1, 40, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[65586, 2356, 173, 3, 56, "Input"],
Cell[65762, 2361, 44, 1, 57, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[65843, 2367, 197, 4, 72, "Input"],
Cell[66043, 2373, 512, 7, 104, "Output"]
}, Open  ]],
Cell[66570, 2383, 34, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[66629, 2387, 44, 1, 40, "Input"],
Cell[66676, 2390, 35, 1, 40, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[66760, 2397, 57, 0, 45, "Subsection"],
Cell[66820, 2399, 570, 14, 235, "Text"],
Cell[67393, 2415, 340, 6, 82, "Text"],

Cell[CellGroupData[{
Cell[67758, 2425, 47, 0, 42, "Subsubsection"],
Cell[67808, 2427, 1121, 28, 473, "Text"],
Cell[68932, 2457, 357, 9, 150, "Text"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

