(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     12531,        374]*)
(*NotebookOutlinePosition[     13201,        398]*)
(*  CellTagsIndexPosition[     13157,        394]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Begin  synodic", "Subsection"],

Cell[BoxData[
    \(\(Clear["\<Months`synodic`\>"];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(BeginPackage["\<Months`synodic`\>", \
"\<Months`Common`MonthsCommon`\>"]\)], "Input",
  InitializationCell->True],

Cell[CellGroupData[{

Cell["data", "Subsubsection"],

Cell["\<\
synodic is NOT accurate to moon, uses average
see Months.notes.nb  nocalendar , synodic and lunisolar\
\>", "Text"],

Cell[BoxData[
    \(\(MonthsInYear[synodic] = 1;\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(leapammount[synodic] = 1;\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(DayNames[synodic] = {Sunday, Monday, Tuesday, Wednesday, Thursday, 
          Friday, Saturday};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(DayNamesStrings[synodic] = Map[SymbolName, DayNames[]];\)\)], "Input",\

  InitializationCell->True],

Cell[BoxData[
    \(\(DayTab[synodic] = {{29}, {30} (*for\ leap\ year*) };\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(MonthDayTab[synodic] = 
      Module[{Private`d, 
          Private`m}, \[IndentingNewLine]{Flatten@
            Table[Table[
                Private`m, {Private`d, \(DayTab[synodic]\)[\([1, 
                      Private`m]\)]}], {Private`m, 1, 
                MonthsInYear[synodic]}], \[IndentingNewLine]Flatten@
            Table[Table[
                Private`m, {Private`d, \(DayTab[synodic]\)[\([2, 
                      Private`m]\)]}], {Private`m, 1, 
                MonthsInYear[synodic]}]\[IndentingNewLine]}]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(GreatestDay[synodic] = 30; LesserYear[synodic] = 29; 
    GreaterYear[synodic] = 30;\)], "Input",
  InitializationCell->True],

Cell["\<\
MonthNames[synodic]={WaxingCrecent,WaxingGibbius,WaningGibbius,\
WaningCrecent};\
\>", "Text"],

Cell[BoxData[{
    \(\(Epoch[synodic, synodic, 
          text] = "\<synodic\>";\)\), "\[IndentingNewLine]", 
    \(\(Epoch[synodic, synodic, type] = lunar;\)\), "\[IndentingNewLine]", 
    \(\(Epoch[synodic, synodic, daystart] = 0;\)\), "\[IndentingNewLine]", 
    \(\(Epoch[synodic, synodic, CDN] = 0;\)\), "\[IndentingNewLine]", 
    \(\(Epoch[synodic, synodic, JDN] = 
        2451549 + 1/2;\)\), "\[IndentingNewLine]", 
    \(\(Epoch[synodic, synodic, date] = {0, 1, 1, 0, 0, 
          0};\)\), "\[IndentingNewLine]", 
    \(\(Epoch[synodic, gregorian, date] = {2000, 1, 6, 0, 0, 
          0};\)\), "\[IndentingNewLine]", 
    \(\(Epoch[synodic, julian, date] = {1999, 12, 24, 0, 0, 0};\)\)}], "Input",\

  InitializationCell->True],

Cell[BoxData[
    \(\(MonthNamesStrings[synodic] = {"\<\>"};\)\)], "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["utils", "Subsubsection"],

Cell[BoxData[
    \(\(Begin["\<`Private`\>"];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(fixdate[dtp_, synodic] := 
      Module[{y, M, d, h, m, s, x, dt, S, calgreg, 
            caljul}, \[IndentingNewLine]dt = 
            fixdatebegin[dtp]; \[IndentingNewLine]If[dt \[Equal] $Failed, 
            Return[$Failed]]; \[IndentingNewLine]calgreg = 
            Epoch[synodic, synodic, date]; \[IndentingNewLine]While[
            Length@dt < 6, 
            AppendTo[dt, 
              calgreg[\([Length@dt + 1]\)]]]; \[IndentingNewLine]{y, M, d, h, 
              m, s} = dt; \[IndentingNewLine]x = 
            MonthsInYear[y, synodic]; \[IndentingNewLine]If[M < 1\  || M > x, 
            Message[Months::"\<unformatted\>", M]; 
            Return[$Failed]]; \[IndentingNewLine]x = 
            DaysInMonth[{y, M}, synodic]; \[IndentingNewLine]If[
            d < 1 || d > x, Message[Months::"\<unformatted\>", d]; 
            Return[$Failed]]; \[IndentingNewLine]If[
            Quotient[h, 24] \[NotEqual] 0, 
            Message[Months::"\<unformatted\>", h]; 
            Return[$Failed]]; \[IndentingNewLine]If[
            Quotient[m, 60] \[NotEqual] 0, 
            Message[Months::"\<unformatted\>", m]; 
            Return[$Failed]]; \[IndentingNewLine]If[
            Quotient[s, 60] \[NotEqual] 0, 
            Message[Months::"\<unformatted\>", s]; 
            Return[$Failed]]; \[IndentingNewLine]dt\[IndentingNewLine]] /; 
        ListQ@dtp || dtp \[Element] Integers\)], "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["synodic calendar  funs", "Subsubsection"],

Cell["ie. 29+1/2+3/100+1/2000+(4/45045)+(1/16453260)//N", "Text"],

Cell[BoxData[
    \(MonthsInYear[year_, synodic] := 1\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(leapdays[yp_?NumericQ, synodic] := 
      Module[{y}, 
        y = Floor[Abs@yp]; \[IndentingNewLine]If[Sign[yp] === 0, 1, 
            Sign[yp]] \((\((Plus @@ 
                  Map[\((Quotient[y, #^\(-1\)])\) &, {1/2, 3/100, 
                      1/2000, \((4/45045)\), \((1/16453260)\)}])\) + 
              If[yp < 0, 0, 1])\)]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(leapdays[{y_, ___}, synodic] := leapdays[y, synodic]\)], "Input",
  InitializationCell->True],

Cell["\<\
given fraction would need to all be 0 on leap ... \
Mod[y,2]\[Equal]0&&Mod[y,100/3]==0&&... so\
\>", "Text",
  InitializationCell->True],

Cell[BoxData[
    \(IsLeapYear[year_?NumericQ, synodic] := 
      leapdays[year - 1, synodic] \[NotEqual] 
        leapdays[year, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(IsLeapYear[{year_, ___}, synodic] := 
      IsLeapYear[year, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(YearFromDays[days_?NumericQ, synodic] := 
      Module[{y, 
          ave}, \[IndentingNewLine]ave = \((LesserYear[synodic] + 1/2 + 
              3/100 + 1/
                2000 + \((4/45045)\) + \((1/
                  16453260)\))\); \[IndentingNewLine]If[
          days \[GreaterEqual] 0, \[IndentingNewLine]Quotient[Floor@days - 1, 
            ave], \[IndentingNewLine]y = 
            Quotient[Floor@\(Abs@days\) + LesserYear[synodic] - 1, 
              ave]; \[IndentingNewLine]y = \(-y\); 
          If[y === 0, 
            y = \(-1\)]; \[IndentingNewLine]y\[IndentingNewLine]]]\)], "Input",\

  InitializationCell->True],

Cell[BoxData[
    \(YearFromDays[{days_, ___}, synodic] := 
      YearFromDays[days, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(DaysInMonth[year_Integer, month_Integer, 
        synodic] := \(DayTab[
            synodic]\)[\([If[IsLeapYear[year, synodic], 2, 1], 
            Floor@month]\)] /; 
        1 <= month \[LessEqual] MonthsInYear[year, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(DaysInMonth[{year_, month_, ___}, synodic] := 
      DaysInMonth[year, month, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(MonthTab[year_?NumericQ, 
        synodic] := \(DayTab[
          synodic]\)[\([If[IsLeapYear[Floor@year, synodic], 2, 
            1]]\)]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(MonthTab[{year_, ___}, synodic] := MonthTab[year, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(MonthDays[year_Integer, month_Integer, synodic] := 
      Plus[Sequence @@ Take[MonthTab[Floor@year, synodic], Floor@month]] /; 
        0 <= month \[LessEqual] MonthsInYear[year, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(MonthDays[{year_, month_, ___}, synodic] := 
      MonthDays[year, month, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(DaysInYear[year_?NumericQ, synodic] := 
      If[IsLeapYear[year, synodic], GreaterYear[synodic], 
        LesserYear[synodic]]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(DaysInYear[{year_, ___}, synodic] := 
      DaysInYear[year, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(YearDay[year_Integer, month_Integer, day_?NumericQ, 
        synodic] := \[IndentingNewLine]MonthDays[year, month - 1, synodic] + 
          day /; 1 <= month \[LessEqual] MonthsInYear[year, synodic] && 
          1 <= day \[LessEqual] DaysInMonth[year, month, synodic]\)], "Input",\

  InitializationCell->True],

Cell[BoxData[
    \(YearDay[{year_, month_, day_, ___}, synodic] := 
      YearDay[year, month, day, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(MonthOfYearDay[year_Integer, yearday_?NumericQ, synodic] := 
      Module[{month, x, i}, \[IndentingNewLine]month = 
            Floor[yearday/GreatestDay[synodic]]; \[IndentingNewLine]If[
            month \[Equal] 0, Return[1]]; \[IndentingNewLine]Do[
            If[MonthDays[year, month, synodic] \[GreaterEqual] yearday, 
              Break[]]; \(++month\), {i, 1, 
              MonthsInYear[year, 
                synodic]}]; \[IndentingNewLine]month\[IndentingNewLine]] /; 
        1 \[LessEqual] Floor@yearday \[LessEqual] 
          DaysInYear[year, synodic]\)], "Input"],

Cell[BoxData[
    \(MonthOfYearDay[year_Integer, yearday_?NumericQ, 
        synodic] := \(MonthDayTab[
            synodic]\)[\([If[IsLeapYear[Floor@year, synodic], 2, 1], 
            yearday]\)] /; 
        1 \[LessEqual] Floor@yearday \[LessEqual] 
          DaysInYear[year, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(MonthOfYearDay[{year_, yearday_, ___}, synodic] := 
      MonthOfYearDay[year, yearday, synodic]\)], "Input",
  InitializationCell->True],

Cell["\<\
dayofweek[dtp_,synodic]:=Module[{dt},
    dt=fixdate[dtp,synodic];If[dt\[Equal]$Failed,Return[$Failed]];
    Mod[Floor@DayNumberDifference2[Epoch[SundayYear,synodic,date],dt,synodic],\
7]+1]\
\>", "Text",
  InitializationCell->True],

Cell[BoxData[
    \(dayofweek[dtp_, synodic] := MoonPhase[dtp, synodic, True]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(dayofweekName[dtp_, synodic] := MoonPhase[dtp, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(ToSeconds[dtp_, synodic] := 
      DayNumberFrom[dtp, synodic, synodic]\ 24\ 60^2\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(FromSeconds[secs_?NumericQ, synodic] := 
      DayNumberTo[secs/\((24\ 60^2)\), synodic, synodic]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(ToSeconds2[dtp_, synodic] := 
      DayNumberFrom2[dtp, synodic, synodic]\ 24\ 60^2\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(FromSeconds2[secs_?NumericQ, synodic] := 
      DayNumberTo2[secs/\((24\ 60^2)\), synodic, synodic]\)], "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["End synodic", "Subsubsection"],

Cell[BoxData[
    \(End[]\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(EndPackage[]\)], "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
AutoGeneratedPackage->None,
WindowSize->{698, 600},
WindowMargins->{{Automatic, 234}, {175, Automatic}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 36, 0, 45, "Subsection"],
Cell[1778, 53, 94, 2, 27, "Input",
  InitializationCell->True],
Cell[1875, 57, 133, 3, 27, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[2033, 64, 29, 0, 42, "Subsubsection"],
Cell[2065, 66, 125, 3, 48, "Text"],
Cell[2193, 71, 91, 2, 27, "Input",
  InitializationCell->True],
Cell[2287, 75, 90, 2, 27, "Input",
  InitializationCell->True],
Cell[2380, 79, 161, 3, 27, "Input",
  InitializationCell->True],
Cell[2544, 84, 122, 3, 27, "Input",
  InitializationCell->True],
Cell[2669, 89, 117, 2, 27, "Input",
  InitializationCell->True],
Cell[2789, 93, 583, 12, 107, "Input",
  InitializationCell->True],
Cell[3375, 107, 145, 3, 43, "Input",
  InitializationCell->True],
Cell[3523, 112, 104, 3, 31, "Text"],
Cell[3630, 117, 739, 14, 139, "Input",
  InitializationCell->True],
Cell[4372, 133, 103, 2, 27, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[4512, 140, 30, 0, 42, "Subsubsection"],
Cell[4545, 142, 88, 2, 27, "Input",
  InitializationCell->True],
Cell[4636, 146, 1458, 27, 267, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[6131, 178, 47, 0, 42, "Subsubsection"],
Cell[6181, 180, 65, 0, 31, "Text"],
Cell[6249, 182, 94, 2, 27, "Input",
  InitializationCell->True],
Cell[6346, 186, 393, 8, 75, "Input",
  InitializationCell->True],
Cell[6742, 196, 113, 2, 27, "Input",
  InitializationCell->True],
Cell[6858, 200, 146, 4, 31, "Text",
  InitializationCell->True],
Cell[7007, 206, 179, 4, 43, "Input",
  InitializationCell->True],
Cell[7189, 212, 130, 3, 27, "Input",
  InitializationCell->True],
Cell[7322, 217, 653, 14, 139, "Input",
  InitializationCell->True],
Cell[7978, 233, 134, 3, 27, "Input",
  InitializationCell->True],
Cell[8115, 238, 288, 6, 59, "Input",
  InitializationCell->True],
Cell[8406, 246, 147, 3, 27, "Input",
  InitializationCell->True],
Cell[8556, 251, 199, 5, 43, "Input",
  InitializationCell->True],
Cell[8758, 258, 119, 2, 27, "Input",
  InitializationCell->True],
Cell[8880, 262, 249, 4, 59, "Input",
  InitializationCell->True],
Cell[9132, 268, 143, 3, 27, "Input",
  InitializationCell->True],
Cell[9278, 273, 188, 4, 43, "Input",
  InitializationCell->True],
Cell[9469, 279, 130, 3, 27, "Input",
  InitializationCell->True],
Cell[9602, 284, 332, 6, 59, "Input",
  InitializationCell->True],
Cell[9937, 292, 150, 3, 27, "Input",
  InitializationCell->True],
Cell[10090, 297, 602, 10, 139, "Input"],
Cell[10695, 309, 329, 7, 59, "Input",
  InitializationCell->True],
Cell[11027, 318, 157, 3, 43, "Input",
  InitializationCell->True],
Cell[11187, 323, 242, 6, 65, "Text",
  InitializationCell->True],
Cell[11432, 331, 118, 2, 27, "Input",
  InitializationCell->True],
Cell[11553, 335, 116, 2, 27, "Input",
  InitializationCell->True],
Cell[11672, 339, 142, 3, 27, "Input",
  InitializationCell->True],
Cell[11817, 344, 158, 3, 27, "Input",
  InitializationCell->True],
Cell[11978, 349, 144, 3, 27, "Input",
  InitializationCell->True],
Cell[12125, 354, 160, 3, 43, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[12322, 362, 36, 0, 42, "Subsubsection"],
Cell[12361, 364, 66, 2, 27, "Input",
  InitializationCell->True],
Cell[12430, 368, 73, 2, 27, "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

