(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     24169,        706]*)
(*NotebookOutlinePosition[     24809,        729]*)
(*  CellTagsIndexPosition[     24765,        725]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["\<\
quick simple: i got this but need other fmt, show me all you can \
give me !\
\>", "Text"],

Cell["\<\
\tquick ex:
\t\t input: GMT,lon,tz,arieslon
\t\toutput: input + SHA,Ra,LHA  (in dn + tm or ang)\
\>", "Text"],

Cell["\<\
the biggest issue is that it deduces what can be known without \
simulation (uses equality based equations of time)\
\>", "Text"],

Cell["\<\
the next biggest issue is that timeDeduce has a built in \
prefference of order to deduce in, it does times before angles (assumes \
angles are measured less accurate).  if your angles are more accurate than \
time: oops - there's no option for that, diy.  (there is a program i wrote \
\"dep-trace\" for dependancy sorting yet i decided that requiring dep data \
for input and leveraging it would add complication people aren't likely to \
ask for)\
\>", "Text"],

Cell["\<\
you may get an mesage in which case the item was found dayless, and \
anything later found using it has any problem incurred by doing so (maybe \
none).  it only does so as a last resort to help add more.  set \
daylessOk=False if you don't want any time/ang figured from, ie: longitude \
alone (dayless).\
\>", "Text"],

Cell["\<\
accuracy: (assuming no eq are backwards) arbitrary prec if input is\
\
\>", "Text"],

Cell[CellGroupData[{

Cell["notes", "Subsection"],

Cell["\<\
while ie GMT is time, it is time on solar calendar. timeDeduce \
cannot convert to/from TAI clock time, of course.\
\>", "Text"],

Cell["\<\
within one day or on same day? theoretically either but hardly \
tested.  conflicting input will not be noticed and cause wrong output. it \
assumes all solar times (don't mix with atomic time if you need accuracy, or \
use DayNumberChange2 if you can)\
\>", "Text"],

Cell["\<\
\tRA[ang]\[Rule]SHA[dn] on input, ang is not used in \
conversions\
\>", "Text"],

Cell["\<\
internal use of day number may not be as you suspect: it's always \
absolute, and internally only HA dn is used, never SHA (gets converted from \
HA).  just look at a few outputs. .5 is noon or midday, so .6 is later, and \
1.6 is one day later.\
\>", "Text"],

Cell["\<\
\tmean T are greg cal yearly, not apparent
\tdo not mix apparent time with mean time unless eq provides ability to
\tdo not mix time with angle unless sure, time usu. is mean time\
\>", "Text"],

Cell["\<\
\t.5 is 12pm apparent any merid, lon at gmt is .5 day
\tex: gmt=lmt+(lon-.5)==.6+(.6-.5)==.7== 2 pm\
\>", "Text"],

Cell[CellGroupData[{

Cell["errata", "Subsubsection"],

Cell["\<\
avoid using UTC, UTC==GMT if used, and allTime cannot convert GMT \
to TAI (only some time eq not needing simulation are tried).  Setting [dn] \
may differ from ones guess (see output using ang) , note dn for RA must be \
set as SHA and output will show RA ang. it's assumed anything set is on or \
within one day, 
ie GMT-LMT+midday==lon (T must be within one day or lon =>1 day).  output is \
meant to show times and angles within one day.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["todo", "Subsubsection"],

Cell["\<\
there is much more deducing that might be done (ie, with EOT, allow \
some atomic time).  height is never used, that needs help (though lets say \
once deduced you can use other app to do it)\
\>", "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["test", "Subsection"],

Cell["\<\
i think work with (any) real calendar will be safer than
\tgmt=ToDate[FromDate[gdate]-TimeZone[] 60 60];
\tUTCsec= UTCsec//FromDate;/ UTC!=Null;\
\>", "Text"],

Cell["\<\
gregorian day numbers are \"dn\" by default.  either switch cal to \
Julian and convert jdn to JDN (epoch), or convert JDN tm/dn to gdn.  angles \
become cal dn internally and get converted back at output\
\>", "Text"],

Cell["\<\
jdn=DayNumberChange2[DayNumberFrom2[gdate,gregorian,gregorian],\
gregorian,julianDayNumber];\
\>", "Text"],

Cell["\<\
aries lon is where sun crosses vernal equinox, here estimated 2014, \
not star\
\>", "Text"],

Cell[BoxData[
    \(Needs["\<timeDeduce`\>"]\)], "Input"],

Cell[BoxData[
    \(\(timeReset[];\)\)], "Input"],

Cell[BoxData[
    \(\(arieslon[ang] = Rationalize[\(-119.05\),  .0001];\)\)], "Input"],

Cell[BoxData[
    \(\({lat[ang], lon[ang]} = {39, \(-77\)};\)\)], "Input"],

Cell[BoxData[
    \(\(localtime[tm] = Date[];\)\)], "Input"],

Cell[BoxData[
    \(\(timezone[dn] = Rationalize[TimeZone[]/24,  .0001];\)\)], "Input"],

Cell["\<\
timeConvert[];
timeTimeRules[1];
timeAngleRules[False,1];
timeShow[gregorian]//TableForm\
\>", "Text"],

Cell[BoxData[
    \(timeDeduce[gregorian]\)], "Input"],

Cell[BoxData[
    \(If[% =!= $Failed, timeShow[gregorian] // TableForm]\)], "Input"],

Cell[BoxData[
    RowBox[{
      TagBox[GridBox[{
            {"\<\"calendar\"\>", "gregorian"},
            {"\<\"arieslon[dn]\"\>", 
              InterpretationBox[
                StyleBox[\(5981/7200\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 5981, 7200]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"lon[dn]\"\>", 
              InterpretationBox[
                StyleBox[\(257/360\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 257, 360]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"GHAaries[dn]\"\>", 
              InterpretationBox[
                StyleBox[\(9581/7200\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 9581, 7200]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"GHAstar[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LHAaries[dn]\"\>", 
              InterpretationBox[
                StyleBox[\(8041/7200\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 8041, 7200]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LHAstar[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LHAsun[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"SHAgm[dn]\"\>", 
              InterpretationBox[
                StyleBox[\(12019/7200\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 12019, 7200]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"SHAlm[dn]\"\>", 
              InterpretationBox[
                StyleBox[\(13559/7200\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 13559, 7200]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"SHAstar[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"RAaries[dn]\"\>", 
              InterpretationBox[
                StyleBox[\(8041/7200\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 8041, 7200]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"RAgm[dn]\"\>", 
              InterpretationBox[
                StyleBox[\(12019/7200\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 12019, 7200]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"RAlm[dn]\"\>", 
              InterpretationBox[
                StyleBox[\(13559/7200\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 13559, 7200]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"RAstar[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"EOT[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"GMT[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LAT[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LMT[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"localtime[dn]\"\>", 
              InterpretationBox[
                StyleBox[\(63572382833/86400\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 63572382833, 86400]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"timezone[dn]\"\>", 
              InterpretationBox[
                StyleBox[\(\(-1\)/6\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ -1, 6]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"UTC[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"AMST[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"AST[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"GMST[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"GST[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LMST[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LST[dn]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"arieslon[ang]\"\>", 
              InterpretationBox[
                StyleBox[\(\(-2381\)/20\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ -2381, 20]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"lon[ang]\"\>", 
              InterpretationBox[
                StyleBox[\(-77\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ -77],
                Editable->True,
                AutoDelete->True]},
            {"\<\"GHAaries[ang]\"\>", 
              InterpretationBox[
                StyleBox[\(9581/7200\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 9581, 7200]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"GHAstar[ang]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LHAaries[ang]\"\>", 
              InterpretationBox[
                StyleBox[\(8041/7200\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 8041, 7200]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LHAstar[ang]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LHAsun[ang]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"SHAgm[ang]\"\>", 
              InterpretationBox[
                StyleBox[\(12019/7200\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 12019, 7200]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"SHAlm[ang]\"\>", 
              InterpretationBox[
                StyleBox[\(13559/7200\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 13559, 7200]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"SHAstar[ang]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"RAaries[ang]\"\>", 
              InterpretationBox[
                StyleBox[\(6379/20\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 6379, 20]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"RAgm[ang]\"\>", 
              InterpretationBox[
                StyleBox[\(2401/20\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 2401, 20]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"RAlm[ang]\"\>", 
              InterpretationBox[
                StyleBox[\(861/20\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ 
                  Rational[ 861, 20]],
                Editable->True,
                AutoDelete->True]},
            {"\<\"RAstar[ang]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"EOT[tm]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"GMT[tm]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LAT[tm]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LMT[tm]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"localtime[tm]\"\>", 
              InterpretationBox[
                StyleBox[\({2014, \ 7, \ 12, \ 11, \ 13, \ 53}\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ {2014, 7, 12, 11, 13, 53}],
                Editable->True,
                AutoDelete->True]},
            {"\<\"timezone[tm]\"\>", 
              InterpretationBox[
                StyleBox[\({\(-1\), \ 12, \ 31, \ 20, \ 0, \ 0}\),
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ {-1, 12, 31, 20, 0, 0}],
                Editable->True,
                AutoDelete->True]},
            {"\<\"UTC[tm]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"AMST[tm]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"AST[tm]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"GMST[tm]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"GST[tm]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LMST[tm]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]},
            {"\<\"LST[tm]\"\>", 
              InterpretationBox[
                StyleBox["Null",
                  ShowStringCharacters->True,
                  NumberMarks->True],
                InputForm[ Null],
                Editable->True,
                AutoDelete->True]}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        (TableForm[ #]&)], " "}]], "Text"],

Cell[CellGroupData[{

Cell["old hack notes", "Subsubsection"],

Cell["\<\
use GHA so lon can by used to span days ?
\tthere is no way to make sense or use of lon out of range
ie, if HA >1 day is to make sense, lon out of range would prevent that
don't forward convert - to + since it can effect days
\t? 1 day + 350 deg or 1 day - 5 deg ?
\tIf[#[ang]<0&&Abs@#[ang]<360,#[angEW]:=#[ang];#[ang]:=360-#[ang]];\
\>", \
"Text"],

Cell["\<\
use Condition to clean code?  no, errors.  doc say definition \
applies only when conditions are met,  there's no clear way to avoid mayhem \
except use of = which is less good
\tx:=Null;y:=Null;x:=y/;x\[Equal]Null&&y\[NotEqual]Null;y:=x/;x\[Equal]Null&&\
y\[NotEqual]Null;
\tx; (* now recursive and also an error *)
use Solve ? i'm thinking two problems 1) may not see all dependancy order 2) \
hard to tell if answer was had  3) eq. eventually involve if then and things \
solve doesn't like\
\>", "Text"],

Cell["\<\
t11=Table[{varsTStr[[i]]<>\"[tm]\",InputForm@varsT[[i]][tm]},{i,1,\
Length@varsTStr}];\
\>", "Text"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
WindowSize->{610, 560},
WindowMargins->{{Automatic, 63}, {85, Automatic}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 100, 3, 31, "Text"],
Cell[1820, 54, 119, 4, 65, "Text"],
Cell[1942, 60, 139, 3, 48, "Text"],
Cell[2084, 65, 473, 8, 116, "Text"],
Cell[2560, 75, 329, 6, 82, "Text"],
Cell[2892, 83, 93, 3, 31, "Text"],

Cell[CellGroupData[{
Cell[3010, 90, 27, 0, 45, "Subsection"],
Cell[3040, 92, 138, 3, 48, "Text"],
Cell[3181, 97, 276, 5, 82, "Text"],
Cell[3460, 104, 90, 3, 31, "Text"],
Cell[3553, 109, 269, 5, 82, "Text"],
Cell[3825, 116, 203, 4, 65, "Text"],
Cell[4031, 122, 123, 3, 48, "Text"],

Cell[CellGroupData[{
Cell[4179, 129, 31, 0, 42, "Subsubsection"],
Cell[4213, 131, 465, 8, 133, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4715, 144, 29, 0, 42, "Subsubsection"],
Cell[4747, 146, 215, 4, 65, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[5011, 156, 26, 0, 45, "Subsection"],
Cell[5040, 158, 168, 4, 65, "Text"],
Cell[5211, 164, 228, 4, 65, "Text"],
Cell[5442, 170, 116, 3, 48, "Text"],
Cell[5561, 175, 102, 3, 31, "Text"],
Cell[5666, 180, 57, 1, 40, "Input"],
Cell[5726, 183, 49, 1, 40, "Input"],
Cell[5778, 186, 86, 1, 40, "Input"],
Cell[5867, 189, 74, 1, 40, "Input"],
Cell[5944, 192, 60, 1, 40, "Input"],
Cell[6007, 195, 87, 1, 40, "Input"],
Cell[6097, 198, 112, 5, 82, "Text"],
Cell[6212, 205, 54, 1, 40, "Input"],
Cell[6269, 208, 84, 1, 40, "Input"],
Cell[6356, 211, 16727, 460, 1001, "Text"],

Cell[CellGroupData[{
Cell[23108, 675, 39, 0, 42, "Subsubsection"],
Cell[23150, 677, 358, 8, 116, "Text"],
Cell[23511, 687, 517, 10, 150, "Text"],
Cell[24031, 699, 110, 3, 48, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

